/********************************************************************
//DM430-AͿʾADCתʾ뵽ADCĵѹֵСλΪV
//MSP430Ƭڲ12λADCڲ2.5V׼ͨתжģʽ
//ͨADC_IN0λԸѹתĵѹʾܴ2.5V
//ܿƲ74HC573ƣö̬ʾƣúλʾ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/

#include <msp430x14x.h>
#include "Config.h"                  //ͷļҪIO˿Ϣ

uint TEMP=0;                         //ADCֵݴ 
uchar count=0;

//***********************************************************************
//               MSP430IOڳʼ
//***********************************************************************
void Port_Init()
{
  LED8SEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  LED8DIR  = 0xFF;                      //IOڷΪ
  LED8PORT = 0xFF;                      //P2ڳʼΪFF
  
  DATASEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  DATADIR  = 0xFF;                      //IOڷΪ
  DATAPORT = 0xFF;                      //P4ڳʼΪFF
  
  CTRSEL  =  0x00;                      //IOΪͨI/Oģʽ˾ʡ
  CTRDIR |=  BIT3 + BIT4;               //IOڷΪ,ƿP63,P64
  CTRPORT =  0xFF;                      //P6ڳʼΪFF  
}

//*************************************************************************
//	74HC573̬ܶɨʾʾɼ¶
//*************************************************************************

void Display(void)
{
  uchar i,j;

  j=0x01;                         //λѡ
  for(i=0;i<5;i++)                //ú3λʾ
  {
     DCTR1;                     
     WCTR1;                     
     DATAPORT=~j;                
     WCTR0;                      
     j=(j<<1);
     DATAPORT=0x00;               //ǰ5λʾ00
     DCTR0;                      
     delay_ms(2);                
  }
  
  DCTR1;                          //ʼʾСǰλ
  WCTR1;                    
  DATAPORT=~j;               
  WCTR0;                    
  j=(j<<1);
  DATAPORT=table[A1] | 0x80;      //ʾС㣬ǰתʱ100⸡㴦        
  DCTR0;                    
  delay_ms(1); 
  
  DCTR1;                          //ʼʾСһλ
  WCTR1;                    
  DATAPORT=~j;               
  WCTR0;                    
  j=(j<<1);
  DATAPORT=table[A2];         
  DCTR0;                    
  delay_ms(1);              

  DCTR1;                         //ʼʾСλ
  WCTR1;                     
  DATAPORT=~j;                
  WCTR0;                      
  j=(j<<1);
  DATAPORT=table[A3];              
  DCTR0;                      
  delay_ms(1);                           
     
  DCTR1;                     
  WCTR1;                     
  DATAPORT=0xff;                
  WCTR0;                      
}

//*************************************************************************
//		ѹݴ
//*************************************************************************
void Data_do(uint temp_d)
{
  uint temp_1,temp_2;
  ulong temp_3;
  
  temp_3=(ulong)(temp_d)*250;            //תʽADCתΪѹСע
  temp_d=temp_3/4095;                    //12λȣ4095
  
  A1=temp_d/100;                        //ֳ٣ʮ͸λ
  temp_1=temp_d%100;
  A2=temp_1/10;
  temp_2=temp_1%10;
  A3=temp_2;
}

//*************************************************************************
//	ADCʼADCؼĴ
//*************************************************************************
void ADC_Init()
{
  P6SEL|=0x01;                                    //ѡADCͨöӦIOڵĹģʽ
  ADC12CTL0|= ADC12ON + MSC + SHT0_2 + REF2_5V + REFON; //ADCԴƿ16CLKڲ׼2.5V
  ADC12CTL1|= SHP + CONSEQ_2 + ADC12SSEL1 + ADC12SSEL0; //SMCLKʱԴ
  ADC12MCTL0= SREF0 + INCH_0;                     //ολͨѡ
  ADC12IE|= 0x01;                                 //ж
  ADC12CTL0|= ENC;                                //ʹת
}

//*************************************************************************
//	ADCжϷ
//*************************************************************************
#pragma vector=ADC_VECTOR
__interrupt void ADC12ISR(void)
{
  uchar j;
  uint result[10];
  
  result[count]=ADC12MEM0;                //ȡADCתֵݴ
  count++;
  while(count>10)
  {
    count=0;
    for(j=0;j<10;j++)
    {
      TEMP+=result[j];                    //ͣ10תĽ
    }
    TEMP=TEMP/10;                         //ƽֵ
    Data_do(TEMP);                        //ADCֵʾ
    for(j=0;j<50;j++)
    {
      Display();                          //ʾADC
    }
  }
}

//***********************************************************************
//            
//***********************************************************************
void main(void)
{ 
  WDT_Init();                         //Źʼ
  Clock_Init();                       //ʱӳʼ
  Port_Init();                        //˿ڳʼڿIO
  Close_LED();                        //LEDȹر
  ADC_Init();                         //ʼADC
  _EINT();                            //ʹж
  
  ADC12CTL0 |= ADC12SC;               //ת
  
  while(1)
  {
  }
}