/********************************************************************
//DM430-AͿ¶ȴDS18B20Ƴʾ¶ȣδУ׼
//DS18b20Cλʾȡǰ¶ȣʾȴ0.1ȣ¶ȷΧ0-99
//DS18B20 ϸŹ1GND źţ2DQš©߽ӿšڼԴ
//ҲṩԴ3VDDѡVDD šڼԴʱűӵء
//DS18B20 ʹ÷DS18B20 õ1Wire Э鷽ʽ
//һʵݵ˫䣬ݽŽP53
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/
#include <msp430x14x.h>
#include "Config.h"

//*************************************************************************
//			ʼIOӳ
//*************************************************************************
void Port_Init()
{
  LED8SEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  LED8DIR  = 0xFF;                      //IOڷΪ
  LED8PORT = 0xFF;                      //P2ڳʼΪFF
  
  DATASEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  DATADIR  = 0xFF;                      //IOڷΪ
  DATAPORT = 0xFF;                      //P4ڳʼΪFF
  
  CTRSEL  =  0x00;                      //IOΪͨI/Oģʽ˾ʡ
  CTRDIR |=  BIT3 + BIT4;               //IOڷΪ,ƿP63,P64
  CTRPORT =  0xFF;                      //P6ڳʼΪFF  
}

//*************************************************************************
//			74HC573̬ܶɨʾʾɼ¶
//*************************************************************************

void Display_DS18B20(uint data_b,uint data_s,uint data_g)
{
  uchar i,j;

  j=0x01;                         //λѡ
  for(i=0;i<5;i++)                //ú3λʾ
  {
     DCTR1;                     
     WCTR1;                     
     DATAPORT=~j;                
     WCTR0;                      
     j=(j<<1);
     DATAPORT=0x00;               //ǰ5λʾ00
     DCTR0;                      
     delay_ms(2);                
  }
  DCTR1;                          //ʼʾ10λ
  WCTR1;                    
  DATAPORT=~j;               
  WCTR0;                    
  j=(j<<1);
  DATAPORT=table[A1];         
  DCTR0;                    
  delay_ms(1);              

  DCTR1;                           //ʼʾλ
  WCTR1;                     
  DATAPORT=~j;                
  WCTR0;                      
  j=(j<<1);
  DATAPORT=table[A2]|0x80;         //ʾС    
  DCTR0;                      
  delay_ms(1);                

  DCTR1;                           //ʼʾС
  WCTR1;                     
  DATAPORT=~j;                
  WCTR0;                      
  j=(j<<1);
  DATAPORT=table[A3];           
  DCTR0;                      
  delay_ms(1);                
     
  DCTR1;                     
  WCTR1;                     
  DATAPORT=0xff;                
  WCTR0;                      
}


//************************************************************************* 
//			DS18B20ʼ
//*************************************************************************

unsigned char DS18B20_Reset(void)                //ʼ͸λ
{
  unsigned char i;
  DQ_OUT;
  DQ_CLR;
  delay_us(500);				//ʱ500uS(480-960)
  DQ_SET;
  DQ_IN;
  delay_us(80);				        //ʱ80uS
  i = DQ_R;
  delay_us(500);				//ʱ500uS(>480uS)
	
  if (i) 
  {
    return 0x00;
  }
  else 
  {
    return 0x01;
  }
}

//************************************************************************* 
//			DS18B20һֽں
//************************************************************************* 
   
unsigned char ds1820_read_byte(void) 
{
  unsigned char i;
  unsigned char value = 0;
  for (i = 8; i != 0; i--) 
  {
    value >>= 1;
    DQ_OUT;
    DQ_CLR;
    delay_us(4);			        //*ʱ4uS	
    DQ_SET;
    DQ_IN;
    delay_us(10);			        //*ʱ10uS	
    if (DQ_R) 
    {
      value|=0x80;		
    }
    delay_us(60);			        //*ʱ60uS	
  }
  return(value);
}

//************************************************************************* 
//			18B20дһֽں
//*************************************************************************  

/*DS18B20ֽд뺯*/
void ds1820_write_byte(unsigned char value) 
{
  unsigned char i;
  for (i = 8; i != 0; i--) 
  {
    DQ_OUT;
    DQ_CLR;
    delay_us(4);			  //ʱ4uS
    if (value & 0x01) 
    {
      DQ_SET;		
    }
    delay_us(80);			  //ʱ80uS
    DQ_SET;			          //λ
    value >>= 1;	
  }
}
//*************************************************************************
//				¶ת
//************************************************************************* 

/*ds1820ת*/
void ds1820_start(void) 
{
  DS18B20_Reset();
  ds1820_write_byte(0xCC);	          //Եַ
  ds1820_write_byte(0x44);	          //ת
}

//*************************************************************************
//				DS8B20ȡ¶Ϣ
//************************************************************************* 

unsigned int ds1820_read_temp(void) 
{
  unsigned int i;
  unsigned char buf[9];

  DS18B20_Reset();
  ds1820_write_byte(0xCC);	          //Եַ
  ds1820_write_byte(0xBE);	          //ȡ¶
  for (i = 0; i < 9; i++) 
  {
    buf[i] = ds1820_read_byte();	
  }
  i = buf[1];
  i <<= 8;
  i |= buf[0];
  temp_value=i;
  temp_value=(uint)(temp_value*0.625);    //ǳ0.0625ԭΪ˰СһλҲתΪʾ
		                          //¶ȱΪ27.5ȣΪںݴеõBCD룬ȷŴ275
                                          //ȻʾʱȷСλüɣʾ27.5
  return i;
}

//*************************************************************************
//		¶ݴ
//*************************************************************************
 void data_do(uint temp_d)
 {
   uint A2t;
   A1=temp_d/100;                         //ֳ٣ʮ͸λ
   A2t=temp_d%100;
   A2=A2t/10;
   A3=A2t%10;
}

//***********************************************************************
//            
//***********************************************************************
void main(void)
{ 
  uchar j;
  
  WDT_Init();                             //Źʼ
  Clock_Init();                           //ʱӳʼ
  Port_Init();                            //˿ڳʼڿIO
  DS18B20_Reset();			  //λD18B20
  while(1)
  {
    ds1820_start();		          //һת
    ds1820_read_temp();		          //ȡ¶ֵ
    data_do(temp_value);                  //ݣõҪʾֵ
    for(j=0;j<200;j++)
    {	    
      Display_DS18B20(A1,A2,A3);          //ʾ¶ֵ
    }		
  }
}