//******************************************************************************
//FATļϵͳ֧ļдĿ¼ļļнĿ¼ļļнļɾļϵͳʽļ
//֧FAT16FAT32ļϵͳļϵͳŲһЭ
//뻷IAR for MSP430 V5.10
//ߣ www.avrgcc.com
//ʱ䣺2010.06.20
//****************************************************************************** 
#include "mmc.h"
#include <stdio.h>
#include "FAT.h"
uint8 BUFFER[512];

uint16 BPB_BytesPerSec;
static uint8 BPB_SecPerClus;
uint16 BPB_RsvdSecCnt;
uint8 BPB_NumFATs;
uint16 BPB_RootEntCnt;
uint16 BPB_TotSec16;
uint16 BPB_FATSz16;
uint32 BPB_HiddSec;

uint32 BPB_FATSz32;
uint32 BPB_RootClus;
uint16 BPB_FSInfo;
uint8  FAT32_EN;                               //Ϊ0ʾFAT16Ϊ1ʾFAT32

uint16 DirectoryCount = 0,FileCount = 0;       //Ŀ¼ļкļ

/***********************************************************************
ܣһ
ݣ1MMC/SDȡ
          2궨οͷļ
***********************************************************************/

void ReadBlock(uint32 LBA)
{
	mmcReadSector(LBA,BUFFER);
        return;
}

/***********************************************************************
ܣдһ
ݣ1MMC/SDд뺯
          2궨οͷļ
***********************************************************************/

void WriteBlock(uint32 LBA)
{
	mmcWriteSector(LBA,BUFFER);
        return;
}

/***********************************************************************
ܣֽݸ
ݣݸƣֽڷʽsizeС
***********************************************************************/

void CopyBytes(void* S, void* D, uint16 size)
{
	uint8 *s = S, *d = D;
	uint16 i;
	for(i = 0; i < size; i++)
		*d++ = *s++;
}

/***********************************************************************
ܣݸ
ݣݸƣַʽsizeС
***********************************************************************/

void CopyWord(void* S, void* D, uint16 size)
{
	uint16 *s = S, *d = D;
	uint16 i;
	for(i = 0; i < size; i++)
		*d++ = *s++;
}

/***********************************************************************
ܣݱȽϺ
ݣ1ȽǷȣȷ1ȷ0
          2ΪʼַݴС
***********************************************************************/

uint8 IsEqual(void* A, void* B, uint8 Size)
{
	uint8 i, *a = A, *b = B;
	for(i = 0; i < Size; i++)
		if(a[i] != b[i])
			return 0;              //ȷ0
	return 1;                              //ȷ1
}

/***********************************************************************
ܣֽ
ݣȫΪ0size0ĴС
***********************************************************************/

void EmptyBytes(void* D, uint16 size)
{
	uint16 i;
	uint8* data = (uint8*)D;
	for(i = 0; i < size; i++)
	{
		*data++ = 0;
	}
}
/***********************************************************************
ܣдMMC/SDFATļϵͳBPB(BIOS Parameter Block)ݽṹ
ݣ1BPBݽṹοͷļ
          2BPBݰ̵߼ṹɣСشСϢ
***********************************************************************/
void FATInit(void)
{
	FAT_BPB* BPB = (FAT_BPB*)BUFFER;
		
	BPB->BPB_BytesPerSec = 0x0200;          //ÿ512ֽ
	BPB->BPB_SecPerClus  = 0x20;            //ÿ8
	BPB->BPB_RsvdSecCnt  = 0x06;          //һ
	BPB->BPB_NumFATs     = 0x02;            //2FAT
	BPB->BPB_RootEntCnt  = 0x200;          //512Ŀ¼
	BPB->BPB_TotSec16    = 0x00;          //
	BPB->BPB_FATSz16     = 0xF1;            //һFATռ
	BPB->BPB_HiddSec     = 0xFD;      //FATǰص
	
	WriteBlock(253);                          //д
}


/***********************************************************************
ܣȡFAT16ļϵͳBPB(BIOS Parameter Block)ݽṹ
ݣ1BPBݽṹοͷļ
          2BPBݰ̵߼ṹɣСشСϢ
***********************************************************************/

void ReadBPB(void)
{
	FAT_BPB* BPB = (FAT_BPB*)BUFFER;
	ReadBlock(0);
        
        ReadBlock(BUFFER[0x1C6]);                  //ȡBPBݶ뻺
        
	BPB_BytesPerSec = BPB->BPB_BytesPerSec;   //Щ¼ݽṹ  
	BPB_SecPerClus = BPB->BPB_SecPerClus;     //ÿʽʱѡÿصĴС2K32K
	BPB_RsvdSecCnt = BPB->BPB_RsvdSecCnt;     //MMC/SDʽ󣬱Ϊ6
	BPB_NumFATs = BPB->BPB_NumFATs;           //2FATһFAT𻵣һ
	BPB_RootEntCnt = BPB->BPB_RootEntCnt;
	BPB_TotSec16 = BPB->BPB_TotSec16;         //Ϊ0BPB_FATSz16¼
	BPB_FATSz16 = BPB->BPB_FATSz16;           //FATռFAT32Ϊ0FAT16Ϊ0
	BPB_HiddSec = BPB->BPB_HiddSec;           //ĬΪ0

}

/***********************************************************************
ܣȡFAT32ļϵͳBPB(BIOS Parameter Block)ݽṹ
ݣ1BPBݽṹοͷļ
          2BPBݰ̵߼ṹɣСشСϢ
***********************************************************************/

void ReadBPB32(void)
{
	FAT32_BPB* BPB = (FAT32_BPB*)BUFFER;
	ReadBlock(253);                             //ȡBPBݶ뻺
        
	BPB_BytesPerSec = BPB->BPB_BytesPerSec;   //Щ¼ݽṹ  
	BPB_SecPerClus = BPB->BPB_SecPerClus;     //ÿʽʱѡÿصĴС2K32K
	BPB_RsvdSecCnt = BPB->BPB_RsvdSecCnt;     //MMC/SDʽ󣬱Ϊ6
	BPB_NumFATs = BPB->BPB_NumFATs;           //2FATһFAT𻵣һ
	BPB_RootEntCnt = BPB->BPB_RootEntCnt;
	BPB_TotSec16 = BPB->BPB_TotSec16;         //Ϊ0BPB_FATSz16¼
	BPB_FATSz16 = BPB->BPB_FATSz16;           //FATռFAT32Ϊ0FAT16Ϊ0
	BPB_HiddSec = BPB->BPB_HiddSec;           //ĬΪ0
        
        BPB_FATSz32 = BPB->BPB_FATSz32;
        BPB_RootClus =BPB->BPB_RootClus;
        BPB_FSInfo = BPB->BPB_FSInfo;
}



/***********************************************************************
ܣȡFATţ֧FAT16/32
ݣ1FATΪ+
          2ĬΪ0
***********************************************************************/

uint32 FATStartSec(void)
{
    return BPB_RsvdSecCnt + BPB_HiddSec; //????????????????????????????
}

/***********************************************************************
ܣȡĿ¼ʼţ֧FAT32
ݣ1Ŀ¼ǹ̶
          2Ŀ¼FAT֮
***********************************************************************/

uint32 DirStartSec(void)
{
  uint32 FATSz;
  if(FAT32_EN==0)
    FATSz=BPB_FATSz16;
  else
    FATSz=BPB_FATSz32;
    return BPB_HiddSec+BPB_RsvdSecCnt + BPB_NumFATs * FATSz;             //+FATFATռ   ??????????????????????
}

/***********************************************************************
ܣȡʼţ֧FAT32
ݣ1ݿʼ
          2FAT32ϵͳBPB_RootEntCnt=0
***********************************************************************/

uint32 DataStartSec(void)
{
	return (uint32)(DirStartSec() + (BPB_RootEntCnt * 32) / BPB_BytesPerSec); //32ΪĿ¼32λļ
}

/***********************************************************************
ܣĿ¼ռFAT16Ч
ݣ1Ŀ¼ռ
          2Ŀ¼ΪΪ32λġļ
          3ļļ
***********************************************************************/

uint16 GetDirSecCount(void)
{
	return BPB_RootEntCnt * 32 / BPB_BytesPerSec;
}

/***********************************************************************
ܣĿ¼ڵһصĴغţFAT32Ч
ݣ1FAT32Ŀ¼ǲȷģFAT16Ϊ̶ֵ512
          2Ŀ¼
***********************************************************************/
uint32 GetDirStartClus(void)
{
	return BPB_RootClus;
}

/***********************************************************************
ܣȡһĴصʼַ
ݣ1ؿʼ    
          2FAT0ƫ
          3ClusIDΪغţΪ2^nֵ24816
***********************************************************************/

uint32 ClusConvLBA(uint16 ClusID)
{
	return DataStartSec() + BPB_SecPerClus * (ClusID - 2);
}

/***********************************************************************
ܣжļϵͳͣFAT16/FAT32еһ֣FAT12Ŀǰ
ݣ1ʵļϵͳ͵жֻΨһķжϴصĴС   
          2FAT12Ĵ4084FAT1665524FAT3265524
          3ȫBPBϢȷԼ
          4ǵFAT32ļϵͳڹ̶FATFATSz16=0
          5ͨFATSz16ǷΪ0жFAT16FAT32
***********************************************************************/
void FATSystemType(void)
{ 
  if(BPB_FATSz16!=0)
    FAT32_EN=0;                            //FAT16ļϵͳ
  else 
    FAT32_EN=1;                            //FAT32ļϵͳ
  
  //return FAT32_EN;
/*    FATSz=BPB_FATSz32;
  if(BPB_TotSec16!=0) 
    TotSec=BPB_TotSec16;
  else
    TotSec=BPB_TotSec32;
  DataSec=TotSec-(BPB_RsvdSecCnt+BPB_NumFATs*FATSz)+RootDirSectors);
  CountofClusters=Data / BPB_SecPerClus;  */
}

/***********************************************************************
ܣȡļָһFATFAT1
ݣ1FATλ֮һ2   
          2ļأÿļӦһFAT
          3FAT16ϵͳԹ2^16ļ
          4¼йļαɢ洢ڲͬϢ
          5ÿļFATռ2ֽڣFAT32ϵͳ4ֽ
***********************************************************************/

uint16 ReadFAT(uint16 Index)
{
	uint16 *RAM = (uint16*)BUFFER;
	ReadBlock(BPB_HiddSec+BPB_RsvdSecCnt + Index / 256);//?????????????
	return RAM[Index % 256];                //ԺǶӦڵƫռ2ֽ
}

uint32 Read32FAT(uint32 Index)
{
	uint32 *RAM = (uint32*)BUFFER;
	ReadBlock(BPB_HiddSec + BPB_RsvdSecCnt + Index / 128);
	return RAM[Index % 128];                //ԺǶӦڵƫռ4ֽ
}



/***********************************************************************
ܣдļָһFATFAT1
ݣ1FATλ֮һ2   
          2ļأÿļӦһFAT
          3FAT16ϵͳԹ2^16ļ
***********************************************************************/

void WriteFAT(uint16 Index, uint16 Value)
{
	uint16 *RAM = (uint16*)BUFFER;
	uint32 SecID;
	SecID = BPB_HiddSec + BPB_RsvdSecCnt + Index / 256;    //ţдFATֵӦ???????????????????????
	ReadBlock(SecID);
	RAM[Index % 256] = Value;                //ļӦFATֵ
	WriteBlock(SecID);
}

void Write32FAT(uint32 Index, uint32 Value)
{
        uint32 *RAM = (uint32*)BUFFER;
	uint32 SecID;
	SecID = BPB_HiddSec + BPB_RsvdSecCnt + Index / 128;    //ţдFATֵӦ
	ReadBlock(SecID);
	RAM[Index % 128] = Value;                //ļӦFATֵ
	WriteBlock(SecID);
}



/***********************************************************************
ܣдļָڶFATFAT2
ݣ1FATλ֮һ2   
          2ļأÿļӦһFAT
          3FAT16ϵͳԹ2^16ļ
***********************************************************************/

void WriteFAT2(uint16 Index, uint16 Value)
{
	uint16 *RAM = (uint16*)BUFFER;
	uint32 SecID;
	SecID = BPB_RsvdSecCnt + BPB_FATSz16 + Index / 256;   //ڶFATڵһFAT
	ReadBlock(SecID);
	RAM[Index % 256] = Value;
	WriteBlock(SecID);
}

void Write32FAT2(uint32 Index, uint32 Value)
{
        uint32 *RAM = (uint32*)BUFFER;
	uint32 SecID;
	SecID = BPB_RsvdSecCnt + BPB_FATSz16 + Index / 128;    //ţдFATֵӦ
	ReadBlock(SecID);
	RAM[Index % 128] = Value;                              //ļӦFATֵ
	WriteBlock(SecID);
}

/***********************************************************************
ܣȡĿ¼пʹõһ
ݣ1ؿʼ    
          2FAT0ƫ
          3ClusIDΪغţΪ2^nֵ24816
          4ʵFileName[0]=0x000xE5ʾΪʹ岻һ
          50x00ʾ֮ǿգûĿ¼Բٲѯ0xE5ʾĿ¼Ϊգʹ
***********************************************************************/

uint16 GetEmptyDIR()
{
	uint16 DirSecCut, DirStart, i, m, ID = 0;
	DirSecCut = 32;               //GetDirSecCount();     //Ŀ¼FAT16FAT32Ϊ512Ŀ¼
	DirStart = DirStartSec();                                            //Ŀ¼ʼַ,FAT16Ϊ512
	for(i = 0; i < DirSecCut; i++)                                       //ռ
	{
		ReadBlock(DirStart + i);                                     //Ŀ¼
		for(m = 0; m < 16; m++)
		{
			if((BUFFER[m * 32] == 0) || (BUFFER[m * 32] == 0xe5))//Ϊ0x000xe5򣬸Ŀ¼Ϊ32λȵġļ
				return ID;                                   //ؿʹID
			else
				ID++;
		}
	}
	return ID;                                                            //ʾûппʹõ
}

/***********************************************************************
ܣȡĿ¼пʹõһ
ݣ1ؿʼ    
          2ԸĿ¼ڿʼصƫ
          3ClusIDΪغţΪ2^nֵ24816
          4ʵFileName[0]=0x000xE5ʾΪʹ岻һ
          50x00ʾ֮ǿգûĿ¼Բٲѯ0xE5ʾĿ¼Ϊգʹ
***********************************************************************/

uint16 GetDirectoryEmptyDIR(uint16 ClusID)
{
	uint16 DirSecCut, DirStart, i, m, ID = 0;
	DirSecCut = BPB_SecPerClus*16;                                       //һļеļĿ¼һһļռһأΪÿ
	DirStart = ClusConvLBA(ClusID);                                      //ļеʼַ
	for(i = 0; i < DirSecCut; i++)                                       //ռ
	{
		ReadBlock(DirStart + i);                                     //Ŀ¼
		for(m = 0; m < 16; m++)
		{
			if((BUFFER[m * 32] == 0) || (BUFFER[m * 32] == 0xe5))//Ϊ0x000xe5򣬸Ŀ¼Ϊ32λȵġļ
				return ID;                                   //ؿʹIDƫ
			else
				ID++;
		}
	}
	return ID;                                                            //ʾûппʹõ
}

/***********************************************************************
ܣúļӦĸĿ¼ԼĿ¼λ
ݣ1Ƚļ   
          2ÿļжӦFAT
          3ID׵ַǶӦĸĿ¼׵ַΪDIR(ͷļfat.h)
***********************************************************************/

uint8 GetFileID(uint8 Name[11], DIR* ID)
{
	uint16 DirSecCut, DirStart, i, m,Index;
	DirSecCut = 32;                                  //GetDirSecCount();Ŀ¼ｫFAT16/32ͳһ512Ŀ¼
	DirStart = DirStartSec();                       //Ŀ¼ʼ
	for(i = 0; i < DirSecCut; i++)
	{
		ReadBlock(DirStart + i);                //ȡ
		for(m = 0; m <16; m++)                  //һ16Ϊÿĳ32λ
		{
			if(IsEqual(Name, &((DIR*)&BUFFER[m * 32])->FileName, 11))   //бȽϣȷindex
			{
				*ID = *((DIR*)&BUFFER[m * 32]);   //IDʵʾǸĿ¼
                                Index = i*16+m;                   //FAT16һ511Ҳ˵FAT16¸Ŀ¼һΪ512Ϊ֤
				return Index;                     //ҵӦĿ¼,Ŀ¼λ.
			}
		}
	}
	return 0;                                         //ûҵӦĿ¼,0.
}

uint8 GetFileID32(uint8 Name[11], DIR32* ID)
{
	uint16 DirSecCut, DirStart, i, m,Index;
	DirSecCut = 32;                                  //GetDirSecCount();Ŀ¼ｫFAT16/32ͳһ512Ŀ¼
	DirStart = DirStartSec();                       //Ŀ¼ʼ
	for(i = 0; i < DirSecCut; i++)
	{
		ReadBlock(DirStart + i);                //ȡ
		for(m = 0; m <16; m++)                  //һ16Ϊÿĳ32λ
		{
			if(IsEqual(Name, &((DIR32*)&BUFFER[m * 32])->FileName, 11))   //бȽϣȷ1
			{
				*ID = *((DIR32*)&BUFFER[m * 32]);   //IDʵʾǸĿ¼
                                Index = i*16+m;                   //FAT16һ511Ҳ˵FAT16¸Ŀ¼һΪ512Ϊ֤
				return Index;                     //ҵӦĿ¼,Ŀ¼λ.
			}
		}
	}
	return 0;                                         //ûҵӦĿ¼,0.
}

/***********************************************************************
ܣȡһյFAT
ݣ1׼дFAT    
          2ÿļжӦFAT
***********************************************************************/

uint16 GetNextFAT(void)
{
	uint16 FAT_Count, i;
	FAT_Count = BPB_FATSz16 * 256;                      //FATһ256FAT16һ2ֽ
	for(i = 0; i < FAT_Count; i++)
	{
		if(ReadFAT(i) == 0)                         //Ϊ0ʾգΪ´ļFAT
			return i;
	}
	return 0;
}

uint32 GetNext32FAT(void)
{
	uint32 FAT_Count, i;
	FAT_Count = BPB_FATSz32 * 128;                      //FATһ128FAT32һ4ֽ
	for(i = 0; i < FAT_Count; i++)
	{
		if(Read32FAT(i) == 0)                         //Ϊ0ʾգΪ´ļFAT
			return i;
	}
	return 0;
}

/***********************************************************************
ܣȡĿ¼ָ
ݣ1ȡָĸĿ¼   
          2һĳ32λһļ
***********************************************************************/

void ReadDIR(uint16 Index, DIR* Value)
{
	uint32 DirStart = DirStartSec();
	ReadBlock(DirStart + Index / 16);
	CopyBytes(&BUFFER[(Index % 16) * 32], Value, 32);
}


/***********************************************************************
ܣдĿ¼ָ
ݣ1½ļʱҵøĿ¼д   
          2һĳ32λһļ
***********************************************************************/

void WriteDIR(uint16 Index, DIR* Value)
{
	uint32 LBA = DirStartSec() + Index / 16;
	ReadBlock(LBA);
	CopyBytes(Value, &BUFFER[(Index % 16) * 32], 32);
	WriteBlock(LBA);
}

void WriteDIR32(uint16 Index, DIR32* Value)
{
	uint32 LBA = DirStartSec() + Index / 16;
	ReadBlock(LBA);
	CopyBytes(Value, &BUFFER[(Index % 16) * 32], 32);
	WriteBlock(LBA);
}

/***********************************************************************
ܣдĿ¼ġ.͡..
ݣ1һ232Bytes  
          2һĳ32λһļ
          3ʼַĿ¼ʼصַ
***********************************************************************/

void WriteDirectoryDIR(uint16 ClusID, uint16 Index, DIR* Value)
{
	uint32 LBA = ClusConvLBA(ClusID);
	ReadBlock(LBA);
	CopyBytes(Value, &BUFFER[(Index % 16) * 32], 32);
	WriteBlock(LBA);
}

void WriteDirectoryDIR32(uint16 Index, DIR32* Value)
{
	uint32 LBA = DirStartSec() + Index / 16;
	ReadBlock(LBA);
	CopyBytes(Value, &BUFFER[(Index % 16) * 32], 32);
	WriteBlock(LBA);
}

/***********************************************************************
ܣļ޸תΪӦʽ20100701תΪ0x3CE1
ݣ1޸ڼ㹫ʽ   
          2Ϊ2ֽڳ
          3ʵʱʱʹãԵõʵʱĸ
***********************************************************************/
uint16 GetFileCrtDate(uint16 Year, uint8 Month, uint8 Day)//ꡢ¡
{
        uint16 FileCrtDate;
        FileCrtDate=(Year-1980)*512+Month*32+Day;    // 0~4λΪ(1~31)58λΪ(1~12)915λΪ(0~127)198011յƫ
        return FileCrtDate;
}

/***********************************************************************
ܣļ޸ʱתΪӦʽ
ݣ1޸ʱ㹫ʽ   
          2ʱΪ2ֽڳ
          3ʵʱʱʹãԵõʵʱĸʱ
***********************************************************************/

uint16 GetFileCrtTime(uint8 Hour, uint8 Min, uint8 Sec)//ʱ֡
{
        uint16 FileCrtTime;
        FileCrtTime=Hour*2048+Min*32+Sec/2;       // 0~4λΪ룬2Ϊ1λ(0~29)510λΪ(0~59)1115λΪʱ(0~23)
        return FileCrtTime;
}



/***********************************************************************
ܣһӿļ
ݣ1ļֻߴдĸС8λÿոչΪո 
          2ļСȲ,Ϊ0;
          3ļĹʵʾдĿ¼FATﲻдļ
          4ļΪ8ֽڣҲ8ַ
          5ļĿ¼д丸Ŀ¼ʼصĿհĿ¼
***********************************************************************/
void CreateDirectoryFile(uint8 DirectoryName[11], uint8 FileName[11])  //ļ½ļļ
{
	uint16 ClusID,ClusIDFile,Index;
        DIR FileDir;
        uint16 FileCrtDateTmp,FileCrtTimeTmp;                 //˫ֽ       
        uint8 FileCrtDate[2],FileCrtTime[2];                  //ֽʱ
 
	FileDir.FilePosit.Start = GetNextFAT();               //õһյFATдӦļFAT       
	ClusID = FileDir.FilePosit.Start;                     //ļؿʼغţļʼصַ
        ClusIDFile = FileDir.FilePosit.Start;                 //ݴԱд

	WriteFAT(ClusID, 0xffff);                             //дӦļFAT1FAT1,0xffffʾļ
        WriteFAT2(ClusID, 0xffff);                            //дӦļFAT2FAT20xffffʾļ     
                             
        Index = GetFileID(DirectoryName,&FileDir);            //õļеԣҪǻʼλãдļĿ¼
        ReadDIR(Index, &FileDir);                             //ȡļеĿ¼ֻҪʼ
        
        FileCrtDateTmp=GetFileCrtDate(2010,7,2);              //ļ޸201072
        FileCrtDate[0]=(uint8)FileCrtDateTmp&0x00ff;          //ֽȡ
        FileCrtDate[1]=(uint8)(FileCrtDateTmp>>8);            //ֽȡ       
        FileCrtTimeTmp=GetFileCrtTime(21,20,10);              //ļ޸ʱ212010
        FileCrtTime[0]=(uint8)FileCrtTimeTmp&0x00ff;          //ֽȡ
        FileCrtTime[1]=(uint8)(FileCrtTimeTmp>>8);            //ֽȡ      
        
        CopyBytes(FileName, &FileDir.FileName, 11);           //дļ
        
        CopyBytes(FileCrtDate, &FileDir.FileCrtDate, 2);       //дļ
        CopyBytes(FileCrtTime, &FileDir.FileCrtTime, 2);       //дļʱ
        
        FileDir.FileAttrib = 0x20;                             //ļ䣬0x10ΪĿ¼ԣļ       
       
        ClusID = FileDir.FilePosit.Start;                      //ļеĿʼغţļĿ¼д
        FileDir.FilePosit.Start=ClusIDFile;                    //½ļʼ
        WriteDirectoryDIR(ClusID,GetDirectoryEmptyDIR(ClusID),&FileDir);//Ҫɨ踸Ŀ¼ʼпհ׿дĿ¼
        
}


/***********************************************************************
ܣڸĿ¼һļļ
ݣ1FileNameļֻߴдĸչҲ   
          2ļСȲ,Ϊ0;
          3ļĹʵʾдĿ¼FATﲻдļ
          4ļΪ8ֽڣҲ8ַ
          5ڶΪԣ0x10ΪļУ0x20Ϊļ
          6ļֻڸĿ¼£Ը
          7Ŀ¼û"."".."Ŀ¼ҲļУ
***********************************************************************/

void CreateFile(uint8 FileName[11], uint8 FileAttrib)
{
	uint16 ClusID;
        DIR FileDir;
        uint8 DirectoryDIRFileName0[11]=".          ";
        uint8 DirectoryDIRFileName1[11]="..         ";
        
        uint16 FileCrtDateTmp,FileCrtTimeTmp;                 //˫ֽ       
        uint8 FileCrtDate[2],FileCrtTime[2];                  //ֽʱ
        
        FileCrtDateTmp=GetFileCrtDate(2012,5,2);              //ļ޸201072
        FileCrtDate[0]=(uint8)FileCrtDateTmp&0x00ff;          //ֽȡ
        FileCrtDate[1]=(uint8)(FileCrtDateTmp>>8);            //ֽȡ
        
        FileCrtTimeTmp=GetFileCrtTime(21,20,10);              //ļ޸ʱ212010
        FileCrtTime[0]=(uint8)FileCrtTimeTmp&0x00ff;          //ֽȡ
        FileCrtTime[1]=(uint8)(FileCrtTimeTmp>>8);            //ֽȡ
        
        
	//ClusNum = Size / (BPB_SecPerClus * 512) + 1;
	EmptyBytes(&FileDir, sizeof(DIR));                          //ȫ0
        CopyBytes(FileName, &FileDir.FileName, 11);                 //дļ
        
        FileDir.FileAttrib = FileAttrib;                            //ļ䣬0x10ΪļУ0x20Ϊļ
        
        CopyBytes(FileCrtDate, &FileDir.FileCrtDate, 2);            //дļ
        CopyBytes(FileCrtTime, &FileDir.FileCrtTime, 2);            //дļʱ
        
	//FileDir.FilePosit.Size = 0;
	FileDir.FilePosit.Start = GetNextFAT();                     //õһյFATдӦļFAT
        
	ClusID = FileDir.FilePosit.Start;                           //ļؿʼغ

	WriteFAT(ClusID, 0xffff);                                   //дӦļFAT1FAT1,0xffffʾļ
        WriteFAT2(ClusID, 0xffff);                                  //дӦļFAT2FAT20xffffʾļ
	WriteDIR(GetEmptyDIR(), &FileDir);                          //дĿ¼ָʹд
        
    
  if(FileDir.FileAttrib==0x10)                                      //ǽļУд.͡..
     {
        CopyBytes(DirectoryDIRFileName0, &FileDir.FileName, 11);    //д".Ŀ¼"ΪĿ¼
        WriteDirectoryDIR(ClusID,0,&FileDir);                       //д룬ַΪ½Ŀ¼ʼصַǰ232BytesΪ0
        
        CopyBytes(DirectoryDIRFileName1, &FileDir.FileName, 11);    //д"..Ŀ¼"Ϊ븸Ŀ¼ϵʼصַΪĿ¼ʼصַ
        FileDir.FilePosit.Start=0x0000;                             //ļλڸĿ¼£ɸΪļеĸļʼصַ
        WriteDirectoryDIR(ClusID,1,&FileDir);                       //д룬ַΪ½Ŀ¼ʼصַǰ232BytesΪ1
     }
}

void FAT32CreateFile(uint8 FileName[11])
{
	uint32 ClusID;
        DIR32 FileDir;
        uint16 FileWrDataTmp,FileWrTimeTmp;                         //˫ֽ       
        uint8 FileWrData[2],FileWrTime[2];                          //ֽʱ
        
        FileWrDataTmp=GetFileCrtDate(2012,5,2);                     //ļ޸201072
        FileWrData[0]=(uint8)FileWrDataTmp&0x00ff;                  //ֽȡ
        FileWrData[1]=(uint8)(FileWrDataTmp>>8);                    //ֽȡ
        
        FileWrTimeTmp=GetFileCrtTime(21,20,10);                     //ļ޸ʱ212010
        FileWrTime[0]=(uint8)FileWrTimeTmp&0x00ff;                  //ֽȡ
        FileWrTime[1]=(uint8)(FileWrTimeTmp>>8);                    //ֽȡ
                
	//ClusNum = Size / (BPB_SecPerClus * 512) + 1;
	EmptyBytes(&FileDir, sizeof(DIR));                          //ȫ0
        CopyBytes(FileName, &FileDir.FileName, 11);                 //дļ
        
        FileDir.FileAttrib = 0x20;                                  //ļ
        
        CopyBytes(FileWrData, &FileDir.DIR_WrtDate, 2);             //дļ޸
        CopyBytes(FileWrTime, &FileDir.DIR_WrtTime, 2);             //дļ޸ʱ
        
	//FileDir.FilePosit.Size = 0;
	ClusID = GetNext32FAT();                                    //õһյFATдӦļFAT
        
	FileDir.DIR_FstClusHI=(uint16)(ClusID>>16);                 //ļʼظ
        FileDir.DIR_FstClusLo=(uint16)ClusID&0x0000ffff;            //ļؿʼغŵ

	Write32FAT(ClusID, 0xffffffff);                             //дӦļFAT1FAT1,0x0fffffffʾļ
        Write32FAT2(ClusID, 0xffffffff);                            //дӦļFAT2FAT2,0x0fffffffʾļ
	WriteDIR32(GetEmptyDIR(), &FileDir);                        //дĿ¼ָʹд
}

/***********************************************************************
ܣɾļ
ݣ1FileNameļֻߴдĸչҲ   
          2ļĿ¼λãȡȽƥķ
          3ļĵһֽд0xE5ʾĿ¼ļ
          4FATдĿ¼
***********************************************************************/

void DelFile(uint8 Name[11])
{
      DIR FileDir;
      uint16 ClusID,Index;
      Index = GetFileID(Name,&FileDir);                      //õļڸĿ¼λ
      FileDir.FileName.NAME[0] = 0xE5;                       //ɾĿ¼ļ
      ClusID = FileDir.FilePosit.Start;                      //ļڵĴغ
      WriteFAT(ClusID,0x0000);                               //նӦFATFAT1
      WriteFAT2(ClusID,0x0000);                              //ʹFAT2FAT1һ
      WriteDIR(Index,&FileDir);                              //дָĿ¼
      
}

void DelFile32(uint8 Name[11])
{
      DIR32 FileDir;
      uint32 ClusID;
      uint16 Index;
      Index = GetFileID32(Name,&FileDir);                      //õļڸĿ¼λ
      FileDir.FileName.NAME[0] = 0xE5;                       //ɾĿ¼ļ
      ClusID = ((uint32)FileDir.DIR_FstClusHI)<<16+(uint32)FileDir.DIR_FstClusLo;  //ļڵĴغ
      Write32FAT(ClusID,0x00000000);                                //նӦFATFAT1
      Write32FAT2(ClusID,0x00000000);                               //ʹFAT2FAT1һ
      WriteDIR32(Index,&FileDir);                                   //дָĿ¼
      
}

/***********************************************************************
ܣļ,ʹͱһ
ݣ1FATFAT1ƵFAT2 
          2FATSz16ʾFATռõBPBȡֵ
          3FAT
***********************************************************************/

void CopyFAT(void)
{
	uint16 FATSz, RsvdSecCnt, i;
        if(FAT32_EN==0) 
          FATSz=BPB_FATSz16;
        else
          FATSz=BPB_FATSz32;
	RsvdSecCnt = BPB_HiddSec + BPB_RsvdSecCnt;
	for(i = 0; i < FATSz; i++)
	{
		ReadBlock(RsvdSecCnt + i);
		WriteBlock(RsvdSecCnt + FATSz + i);
	}
}

/***********************************************************************
ܣFAT16ļݣֶ֧д
ݣ1WriteΪ1дΪ0ǶStartΪʼֽڣLengthΪ 
          2DataΪݣд뻺
          3ҪͬFAT¼ļռСλ
***********************************************************************/

void OperateFile(uint8 Write ,uint8 Name[11], uint32 Start, uint32 Length, void* Data)
{
	uint8 *data = Data;
	uint16 BytePerClus, SecPerClus, ClusNum, ClusNext,ClusID,ClusIDValue ,m,Index;
	uint32 LBA, i,length;
	DIR FileDir;
	SecPerClus = BPB_SecPerClus;
	BytePerClus = BPB_SecPerClus * BPB_BytesPerSec;               //ÿصֽ
	Index = GetFileID(Name, &FileDir);                            //ļĿ¼λ0511
        length = Length;

	//㿪ʼλڴصĴغ
	ClusNum = Start / BytePerClus;
	ClusID = FileDir.FilePosit.Start;

	for(i = 0; i < ClusNum; i++)
	{
                ClusIDValue = ReadFAT(ClusID);                        //ȡӦļFAT0xFFFFʾļ
		WriteFAT(ClusID, 0xffff);
                WriteFAT2(ClusID, 0xffff);
                if(ClusIDValue==0xffff)                               //ClusIDValueֵΪ0xFFFFıʾһصַ
                  ClusNext = GetNextFAT();
                else
                  ClusNext = ClusIDValue; 
                
		WriteFAT(ClusID, ClusNext);
                WriteFAT2(ClusID, ClusNext);
		ClusID = ClusNext;
	}
        WriteFAT(ClusID, 0xffff);
        WriteFAT2(ClusID, 0xffff);

	//㿪ʼλƫ
	i = (Start % BytePerClus) / 512;

	//㿪ʼλƫ
	m = (Start % BytePerClus) % 512;

	LBA = ClusConvLBA(ClusID) + i;


		for(i = 0; i < SecPerClus; i++)
		{
			if(Write)
				ReadBlock(LBA);
			else
				ReadBlock(LBA++);

			for(m = 0; m < 512; m++)
			{

				if(Write)
					BUFFER[m] = *data++;
				else
					*data++ = BUFFER[m];

				//ȡɾ˳
				if(--Length == 0)
				{
					if(Write)
                                        {
                                                //д
						WriteBlock(LBA); 
                                               //дĿ¼
                                                FileDir.FilePosit.Size = Start+length;
                                                WriteDIR(Index,&FileDir);
                                        }
					return;
				}
			}
			if(Write)
				WriteBlock(LBA++); //д,ָ
		}
	}

/***********************************************************************
ܣFAT32ļݣֶ֧д
ݣ1WriteΪ1дΪ0ǶStartΪʼֽڣLengthΪ 
          2DataΪݣд뻺
          3ҪͬFAT¼ļռСλ
***********************************************************************/

void Operate32File(uint8 Write ,uint8 Name[11], uint32 Start, uint32 Length, void* Data)
{
	uint8 *data = Data;
	uint16 BytePerClus, SecPerClus, ClusNum ,m,Index;
        uint32 ClusID,ClusIDValue, ClusNext;
	uint32 LBA, i,length;
	DIR32 FileDir;
	SecPerClus = BPB_SecPerClus;
	BytePerClus = BPB_SecPerClus * BPB_BytesPerSec;               //ÿصֽ
	Index = GetFileID32(Name, &FileDir);                            //ļĿ¼λ0511
        length = Length;

	//㿪ʼλڴصĴغ
	ClusNum = Start / BytePerClus;
        ClusID=((uint32)FileDir.DIR_FstClusHI<<16)+(uint32)FileDir.DIR_FstClusLo;
  	for(i = 0; i < ClusNum; i++)
	{
                ClusIDValue = Read32FAT(ClusID);                        //ȡӦļFAT0xFFFFʾļ
		Write32FAT(ClusID, 0x0fffffff);
                Write32FAT2(ClusID, 0x0fffffff);
                if(ClusIDValue==0x0fffffff)                               //ClusIDValueֵΪ0xFFFFıʾһصַ
                  ClusNext = GetNext32FAT();
                else
                  ClusNext = ClusIDValue; 
                
		Write32FAT(ClusID, ClusNext);
                Write32FAT2(ClusID, ClusNext);
		ClusID = ClusNext;
	}
        Write32FAT(ClusID, 0x0fffffff);
        Write32FAT2(ClusID, 0x0fffffff);

	//㿪ʼλƫ
	i = (Start % BytePerClus) / 512;

	//㿪ʼλƫ
	m = (Start % BytePerClus) % 512;

	LBA = ClusConvLBA(ClusID) + i;


		for(i = 0; i < SecPerClus; i++)
		{
			if(Write)
				ReadBlock(LBA);
			else
				ReadBlock(LBA++);

			for(m = 0; m < 512; m++)
			{

				if(Write)
					BUFFER[m] = *data++;
				else
					*data++ = BUFFER[m];

				//ȡɾ˳
				if(--Length == 0)
				{
					if(Write)
                                        {
                                                //д
						WriteBlock(LBA); 
                                               //дĿ¼
                                                FileDir.DIR_FileSize = Start+length;
                                                WriteDIR32(Index,&FileDir);
                                        }
					return;
				}
			}
			if(Write)
				WriteBlock(LBA++); //д,ָ
		}
	}

/***********************************************************************
ܣʽ
ݣ1ϵĸʽֻĿ¼
          2ʵļȻ
***********************************************************************/

void FormatCard(void)
{
    uint16 i,DirStart,DirSecNum,FatStart,FatSecNum;
   
    //ReadBPB();

    for(i = 0; i < 512;i++ )BUFFER[i]=0;                  //Ŀ¼0
    DirSecNum = GetDirSecCount();                          //FAT16ĸĿ¼λ512ռ32FAT32Ŀ¼
    DirStart = DirStartSec();                              //ȡĿ¼ʼַ
    for(i=0;i<DirSecNum;i++)                               //0
    {
      WriteBlock(DirStart+i);
    }
 

    FatStart = BPB_HiddSec + BPB_RsvdSecCnt;              //FAT
    FatSecNum = BPB_FATSz16;                              //FATռС
    for(i=0;i<FatSecNum;i++)
    {
      WriteBlock(FatStart+i);
    }
    WriteFAT(0,0xfff8);                                   //FATĵһ̶ֹΪ0xfff8
    WriteFAT(1,0xffff);                                   //FATĵڶ̶ֹΪ0xffff

    CopyFAT();                                            //FATFAT1һ
    

}
       
/***********************************************************************
ܣĿ¼ļкļ
ݣ1Ŀ¼Ŀ¼Լ 
          2жļͣļСtxtļBMPļMP3ļ
          3ļ
***********************************************************************/  
void FileCountSearch(void)
{/*
	uint16 BytePerClus, SecPerClus, ClusNum, ClusNext,ClusID,ClusIDValue ,m,Index;
	uint32 LBA, i;
	DIR FileDir;
	SecPerClus = BPB_SecPerClus;
	BytePerClus = BPB_SecPerClus * BPB_BytesPerSec;               //ÿصֽ
	Index = GetFileID(Name, &FileDir);                            //ļĿ¼λ0511
  
      */  
        uint16 DirSecCut, DirStart, i, m;//, Count = 0;
	DirSecCut = 32;                                               //Ŀ¼FAT16FAT32Ϊ512Ŀ¼
	DirStart = DirStartSec();                                     //Ŀ¼ʼַ,FAT16Ϊ512
        DirectoryCount = 0,FileCount = 0;
	for(i = 0; i < DirSecCut; i++)                                //ռ
	{
		ReadBlock(DirStart + i);                              //Ŀ¼
		for(m = 0; m < 16; m++)
		{
			if((BUFFER[m * 32] != 0) && (BUFFER[m * 32] != 0xe5))//Ϊ0x000xe5򣬸Ŀ¼Ϊ32λȵġļ
                        {
                          if(BUFFER[m * 32+11] == 0x10)               //0x10Ϊļ
                            DirectoryCount++;
                          if(BUFFER[m * 32+11] == 0x20)               //0x20Ϊļ
                            FileCount++;
                        //  else
                            //Count=0;
			}
		}
	}
}
