
typedef unsigned char uint8;
typedef unsigned int uint16;
typedef unsigned long uint32;

//uint8 FAT32_EN;                       //FATļϵͳͣΪ0ʾFAT16Ϊ1ʾFAT32

#pragma pack(1)

//#if FAT32_EN=0

typedef struct
{
	uint8 BS_jmpBoot[3];       //תָ
	uint8 BS_OEMName[8];       //
	uint16 BPB_BytesPerSec;    //ÿֽһΪ512
	uint8 BPB_SecPerClus;      //ÿص
	uint16 BPB_RsvdSecCnt;     //FAT12/16Ϊ1
	uint8 BPB_NumFATs;         //FATṹĿһΪ2
	uint16 BPB_RootEntCnt;     //Ŀ¼ĿFAT12Ϊ224FAT16Ϊ512
	uint16 BPB_TotSec16;       //
	uint8 BPB_Media;           //豸̡ͣ洢MMC/SDΪ0xF8
	uint16 BPB_FATSz16;        //FATռ
	uint16 BPB_SecPerTrk;      //ŵ
	uint16 BPB_NumHeads;       //ͷ
	uint32 BPB_HiddSec;        //ĬΪ0
	uint32 BPB_TotSec32;       // BPB_TotSec16 Ϊ0¼
	uint8 BS_DrvNum;           //ж0x13
	uint8 BS_Reservedl;        //WINDOWS NTʹ
	uint8 BS_BootSig;          //չ
	uint32 BS_VolID;           //к
	uint8 BS_VolLab[11];       //꣬11ֽ
	uint8 BS_FilSysType[8];    //ļϵͳ־
	uint8 ExecutableCode[448]; //롢ݼ
	uint8 ExecutableMarker[2]; //־0x55aa̶ֵ
} FAT_BPB;

//#else

typedef struct
{
	uint8 BS_jmpBoot[3];       //תָ
	uint8 BS_OEMName[8];       //
	uint16 BPB_BytesPerSec;    //ÿֽһΪ512
	uint8 BPB_SecPerClus;      //ÿص
	uint16 BPB_RsvdSecCnt;     //FAT12/16Ϊ1
	uint8 BPB_NumFATs;         //FATṹĿһΪ2
	uint16 BPB_RootEntCnt;     //Ŀ¼ĿFAT12Ϊ224FAT16Ϊ512FAT32Ϊ0
	uint16 BPB_TotSec16;       //
	uint8 BPB_Media;           //豸̡ͣ洢MMC/SDΪ0xF8
	uint16 BPB_FATSz16;        //FATռ
	uint16 BPB_SecPerTrk;      //ŵ
	uint16 BPB_NumHeads;       //ͷ
	uint32 BPB_HiddSec;        //ĬΪ0
	uint32 BPB_TotSec32;       // BPB_TotSec16 Ϊ0¼
	uint32 BPB_FATSz32;         //FAT32ϵͳеһFATռ
	uint16 BPB_ExtFlags;        //FAT32
        uint16 BPB_FSVer;           //FAT32汾ţһΪ0
        uint32 BPB_RootClus;        //Ŀ¼ڵĵһصĴغţͨΪ2ǱΪ2
        uint16 BPB_FSInfo;          //FAT32FSINFOṹռһΪ1
        uint16 BPB_BkBootSec;       //Ϊ0ʾڱ¼ıռͨΪ66ʼ
        uint8  BPB_Reserved[12];    //ڽչһ0
        uint8  BS_DrvNum;           //0x13жϲ
        uint8 BS_Reservedl;        //WINDOWS NTʹ
	uint8 BS_BootSig;          //չ
	uint32 BS_VolID;           //к
	uint8 BS_VolLab[11];       //꣬11ֽ
	uint8 BS_FilSysType[8];    //ļϵͳ־
	uint8 ExecutableCode[420]; //롢ݼ
	uint8 ExecutableMarker[2]; //־0x55aa̶ֵ
} FAT32_BPB;

typedef struct
{       
        uint32 FSI_LeadSig;         //ֵΪ0x41615252ʾΪFSInfo
        uint8  FSI_Reserved1[480];  //չ
        uint32 FSI_StrucSig;        //ֵΪ0x61417272ıѾʹ
        uint32 FSI_Free_Count;      //µʣ
        uint32 FSI_Nxt_free;        //趨ΪȥĴغţΪ0xFFFFFFFFӴ2ʼңFAT
        uint8  FSI_Reserved2[12];   //
        uint32 FSI_TrailSig;        //ֵΪ0xAA550000
} FSInfo;
        
//#endif

typedef struct
{
	uint8 NAME[8];                //8ֽڳȵļ
	uint8 TYPE[3];                //ļչ3ֽڳ
} FILE_NAME;
typedef struct
{
	uint16 Start;                 //ļʼغ
	uint32 Size;                  //ļС
} FILE_POSIT;
typedef struct
{
	FILE_NAME FileName;           //ļ8ֽļ3ֽչļ8ַ
	uint8 FileAttrib;             //ļԣΪ0x20
	uint8 UnUsed;                  //ռ䣬Ϊ0
        
        uint8  FileCrtTimeTeenth;      //ļʱĺ뼶ʱЧֵ0199
        uint8  FileCrtTime[2];         //ļʱ
        uint8  FileCrtDate[2];         //ļ
        uint16 FileLastAccDate;        //
        uint16 FileFstClusHI;          //Ŀ¼غŵĸλ֣FAT16Ϊ0
        
	uint8 FileUpdateTime[2];      //һļʱ
	uint8 FileUpdateData[2];      //ļд  0~4λΪ(1~31)58λΪ(1~12)915λΪ(0~127)198011յƫ
	FILE_POSIT FilePosit;         //ļʼؼС
} DIR;                                //FAT16Ŀ¼ṹ

typedef struct
{
	FILE_NAME FileName;            //ļ8ֽļ3ֽչļ8ַ
	uint8  FileAttrib;             //ļԣΪ0x20
	uint8  DIR_NTRes;              //WINDOWS NTʹãΪ0
        uint8  DIR_CrtTimeTeenth;      //ļʱĺ뼶ʱЧֵ0199
        uint16 DIR_CrtTime;            //ļʱ
        uint16 DIR_CrtDate;            //ļ
        uint16 DIR_LastAccDate;        //
        uint16 DIR_FstClusHI;          //Ŀ¼غŵĸλ֣FAT16Ϊ0
        uint8  DIR_WrtTime[2];         //дʱ䣬ļΪд
        uint8  DIR_WrtDate[2];         //дڣļΪд
        uint16 DIR_FstClusLo;          //Ŀ¼غŵĵλ
	uint16 DIR_FileSize;           //ļС32λ˫
} DIR32;                               //FAT32ϵͳļĿ¼

typedef struct
{
	uint16 ClusID;                 //ʼغ
	uint16 SecOfClus;              //ÿ
	uint16 ByteOfSec;              //ÿֽ
} DATA_POSIT;

#pragma pack()


void ReadBlock(uint32 LBA);
void WriteBlock(uint32 LBA);
void CopyBytes(void* S, void* D, uint16 size);
uint8 IsEqual(void* A, void* B, uint8 Size);
void EmptyBytes(void* D, uint16 size);
void FATInit(void);
void ReadBPB(void);
void ReadBPB32(void);
uint32 FATStartSec(void);
uint32 DirStartSec(void);
uint32 DataStartSec(void);
uint16 GetDirSecCount(void);
uint32 GetDirSartClus(void);
uint32 ClusConvLBA(uint16 ClusID);
uint16 ReadFAT(uint16 Index);
void WriteFAT(uint16 Index, uint16 Value);
void WriteFAT2(uint16 Index, uint16 Value);
uint16 GetEmptyDIR(void);
uint8 GetFileID(uint8 Name[11], DIR* ID);
uint16 GetNextFAT(void);
void ReadDIR(uint16 Index, DIR* Value);
void WriteDIR(uint16 Index, DIR* Value);
void CreateFile(uint8 FileName[11],uint8 FileAttrib);
void FAT32CreateFile(uint8 FileName[11]);

//void CreateDirectoryFile(uint8 FileName[11]);
void CreateDirectoryFile(uint8 DirectoryName[11], uint8 FileName[11]);
void CopyFAT(void);
void OperateFile(uint8 Write ,uint8 Name[11], uint32 Start, uint32 Length, void* Data);
void DelFile(uint8 Name[11]);
void FormatCard(void);
void FATSystemType(void);
