/********************************************************************
//DM430-Aƴֿ12864ҺģʾԳʾ2ͼƬ
//ʾģʽΪģʽֱӽ1286412864ӿڼɣ⣬Һλ
//עѡҺĵԴλڵλѡ5V3.3VҺѹѡ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/
#include <msp430x14x.h>
#include "Config.h"
#include "Picture.c"

#define X1address       0x80        //12864ϰXʼַ
#define X2address       0x88        //12864°Xʼַ
#define Yaddress        0x80        //Yʼַ

//*************************************************************************
//	ʼIOӳ
//*************************************************************************
void Port_Init()
{
  P4SEL = 0x00;
  P4DIR = 0xFF;
  P5SEL = 0x00;
  P5DIR|= BIT0 + BIT1 + BIT5 + BIT6 + BIT7;
  PSB_SET;		          //Һڷʽ
  RST_SET;		          //λRSTø
}

//***********************************************************************
//	ʾд뺯
//***********************************************************************
void LCD_write_com(unsigned char com) 
{	
  RS_CLR;
  RW_CLR;
  EN_SET;
  DataPort = com;
  delay_ms(5);
  EN_CLR;
}

//***********************************************************************
//	ʾд뺯
//***********************************************************************
void LCD_write_data(unsigned char data) 
{
  RS_SET;
  RW_CLR;
  EN_SET;
  DataPort = data;
  delay_ms(5);
  EN_CLR;
}

//***********************************************************************
//	ʾʾ
//***********************************************************************

void LCD_clear(void) 
{
  LCD_write_com(0x01);
  delay_ms(5);
}

//***********************************************************************
//ƣDisplayCgrom(uchar hz)ʾCGROMĺ
//***********************************************************************
void DisplayCgrom(uchar addr,uchar *hz)
{
  LCD_write_com(addr);
  delay_ms(5);
  while(*hz != '\0')  
  {
    LCD_write_data(*hz);
    hz++;
    delay_ms(5);
  }

} 

//****************************************************************
//ƣDisplay()ʾԽ
//****************************************************************
void Display(void)
{
  DisplayCgrom(0x80,"͵ӻӭ");
  DisplayCgrom(0x88,":jingyehanxing");
  DisplayCgrom(0x90,"www.avrgcc.com  ");
  DisplayCgrom(0x98,"绰057487476870");
}

//***********************************************************************
//	ʾʼ
//***********************************************************************
void LCD_init(void) 
{
  LCD_write_com(FUN_MODE);			//ʾģʽ
  delay_ms(5);
  LCD_write_com(FUN_MODE);			//ʾģʽ
  delay_ms(5);
  LCD_write_com(DISPLAY_ON);			//ʾ
  delay_ms(5);
  LCD_write_com(CLEAR_SCREEN);			//
  delay_ms(5);
}

//****************************************************************
//ƣDisplay_photo(uchar *hz)ʾԶͼΣ°д
//****************************************************************

void Display_photo1(const uchar *img1)           //дϰͼݺ
{
   int i,j;     

   for(i=0;i<32;i++)                             //ϰ32
    {  
		LCD_write_com(FUN_MODEK);        //չָͼʾ
        delay_ms(1);
     
 		LCD_write_com(Yaddress+i);       //дֱַYַԶһ
        delay_ms(1);

        LCD_write_com(X1address);                //дˮƽַXַ
        delay_ms(1);
      
 	for(j=0;j<8;j++)                         //д2ֽڵݣһ8ΣΪһУ16*8λ
        {  			                                     
		LCD_write_data(img1[i*16+j*2]);
		delay_ms(2);                     //ʱǱģΪûжҺæԽʱ
		LCD_write_data(img1[i*16+j*2+1]); 
		delay_ms(2);          
        }

    }
}

void Display_photo2(const uchar *img2)           //д°ͼ
{
	int i,j;

	for(i=0;i<32;i++)                        //°32
	{  

	 	LCD_write_com(Yaddress+i);       //дֱַYַԶһ
	    delay_ms(1);
		LCD_write_com(X2address);        //дˮƽַXַ
	    delay_ms(1);
	 	 for(j=0;j<8;j++)                //д2ֽڵݣһ8ΣΪһУ16*8λ
	    {
			
			LCD_write_data(img2[i*16+j*2]);
			delay_ms(2);                    
			LCD_write_data(img2[i*16+j*2+1]);  
			delay_ms(2);  
      
		}

	}

}

//****************************************************************
//ƣӳʾͼ
//****************************************************************

int main(void)
{
  WDT_Init();                                   //Ź
  Clock_Init();                                 //ϵͳʱ
  Port_Init();                                  //ϵͳʼIO
  Close_LED();                                  //رLEDܣʾ
  delay_ms(100);                                //ʱ100ms
  LCD_init();                                   //Һʼ
  LCD_clear();                                  //
  while(1)
  {
    Display_photo1(photo1);                     //ʾϰݣһͼ
    Display_photo2(photo2);                     //ʾ°
    delay_ms(1000);
    delay_ms(1000);
    
    Display_photo1(photo3);                     //ʾϰݣڶͼ
    Display_photo2(photo4);                     //ʾ°
    delay_ms(1000);
    delay_ms(1000);
  }
}

