/********************************************************************
//DM430-AͿ1602ҺģʾԳʾӭϢ
//ֱӽ16021602ӿڼɣ泯ڣλϷ
//עѡҺĵԴλڵλѡ5V3.3VҺѹѡ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/
#include <msp430x14x.h>
#include "Config.h"

#define CPU_F ((double)8000000) 
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0)) 
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0)) 

#define uchar unsigned char
#define uint  unsigned int
#define ulong unsigned long

//*************************************************************************
//			ʼIOӳ
//*************************************************************************
void Port_init()
{

	P4SEL = 0x00;
        P4DIR = 0xFF;                   //ݿģʽ
        P5SEL = 0x00;
        P5DIR|= BIT5 + BIT6 + BIT7;     //ƿΪģʽ
}

//***********************************************************************
//	ʾд뺯
//***********************************************************************
void LCD_write_com(unsigned char com) 
{	
	RS_CLR;
	RW_CLR;
	EN_SET;
	DataPort = com;                 //д˿
	delay_ms(5);
	EN_CLR;
}

//***********************************************************************
//	ʾд뺯
//***********************************************************************
void LCD_write_data(unsigned char data) 
{
	RS_SET;
	RW_CLR;
	EN_SET;
	DataPort = data;                //д˿
	delay_ms(5);
	EN_CLR;
}

//***********************************************************************
//	ʾʾ
//***********************************************************************
void LCD_clear(void) 
{
	LCD_write_com(0x01);            //Ļʾ
	delay_ms(5);
}

//***********************************************************************
//	ʾַд뺯
//***********************************************************************
void LCD_write_str(unsigned char x,unsigned char y,unsigned char *s) 
{
	
    if (y == 0) 
    {
    	LCD_write_com(0x80 + x);        //һʾ
    }
    else 
    {
    	LCD_write_com(0xC0 + x);        //ڶʾ
    }
    
    while (*s) 
    {
    	LCD_write_data( *s);
    	s ++;
    }
}

//***********************************************************************
//	ʾַд뺯
//***********************************************************************
void LCD_write_char(unsigned char x,unsigned char y,unsigned char data) 
{
	
    if (y == 0) 
    {
    	LCD_write_com(0x80 + x);        //һʾ
    }
    else 
    {
    	LCD_write_com(0xC0 + x);        //ڶʾ
    }
    
    LCD_write_data( data);  
}

//***********************************************************************
//	ʾʼ
//***********************************************************************
void LCD_init(void) 
{
    LCD_write_com(0x38);		//ʾģʽ  
    delay_ms(5);
    LCD_write_com(0x08);		//ʾر
    delay_ms(5);
    LCD_write_com(0x01);		//ʾ
    delay_ms(5);
    LCD_write_com(0x06);		//ʾƶ
    delay_ms(5);
    LCD_write_com(0x0C);		//ʾ
    delay_ms(5);
}

//***********************************************************************
//      
//***********************************************************************
void main(void)
{
     uchar i,*p;
     WDT_Init();                         //Ź
     Clock_Init();                       //ϵͳʱ
     Port_init();                        //ϵͳʼIO
     Close_LED();
     delay_ms(100);                      //ʱ100ms
     LCD_init();                         //Һʼ
     LCD_clear();                        //
     while (1) 
      {
		i = 1;
		p = "www.avrgcc.com";                //ַʾ
		LCD_clear();
		LCD_write_str(0,0,"Welcome");
		delay_ms(250);
		
		while (*p) {
			LCD_write_char(i,1,*p);      //ַʾ
			i ++;
			p ++;
			delay_ms(250);               //ʱ250ms
			}
		delay_ms(250);
      }
}