/********************************************************************
//DM430-AͿRS485ͨʵ飬ͨԽͨţ485UART1
//Զ˱رRS232תRS485ģ飬޷ֱӵ
//RS485֮ͨ˫ӣԲʹ120ŷƥ
//ԶͨڵֲȽɵԷ
//Ὣյٷ͵ڵ֣ղжģ飬òѯ
//صBSLģͨñΪUSBתģʽʼǱûдڿֱӴ
//BSLRXDTXD0ӣTXDRXD0Ӽ
//עʹBSLģΪUSBתڹܵʱRTSTCKñDTRRESETñҪϿ
//ʸͨconfig.hļֱӸbaud
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/

#include <msp430x14x.h>
#include "Config.h"                     //ͷļҪIO˿Ϣ

//***********************************************************************
//               MSP430IOڳʼ
//***********************************************************************
void Port_Init()
{
  LED8SEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  LED8DIR  = 0xFF;                      //IOڷΪ
  LED8PORT = 0xFF;                      //P2ڳʼΪFF
  
  DATASEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  DATADIR  = 0xFF;                      //IOڷΪ
  DATAPORT = 0xFF;                      //P4ڳʼΪFF
  
  CTRSEL  =  0x00;                      //IOΪͨI/Oģʽ˾ʡ
  CTRDIR |=  BIT3 + BIT4;               //IOڷΪ,ƿP63,P64
  CTRPORT =  0xFF;                      //P6ڳʼΪFF  
  
  P2DIR |= BIT0;                        //P20ΪRS485ƿڣģʽ
  P2OUT |= BIT0;                        //øP20
}

//*************************************************************************
//               MSP430ڳʼ
//*************************************************************************
void UART_Init()
{
  U1CTL|=SWRST + CHAR;                //λSWRST8λģʽ
  U1TCTL|=SSEL1;                      //SMCLKΪʱ
  U1BR1=baud_h;                       //BRCLK=8MHZ,Baud=BRCLK/N
  U1BR0=baud_l;                       //N=UBR+(UxMCTL)/8
  U1MCTL=0x00;                        //΢ĴΪ09600bps
  ME2|=UTXE1;                         //UART1ʹ
  ME2|=URXE1;                         //UART1ʹ
  U1CTL&=~SWRST;
  IE2|=URXIE1;                        //жʹλ
  
  P3SEL|= BIT6 + BIT7;                //IOΪڶģʽUART
  P3DIR|= BIT6;                       //TXD1ڷΪ
}

//*************************************************************************
//              1ݺ
//*************************************************************************

void Send_Byte(uchar data)
{
  RS485_CTR1;
  while(!(IFG2&UTXIFG1));             //ͼĴյʱ
  U1TXBUF=data;
  //RS485_CTR0;
}

//*************************************************************************
//              1ַ
//*************************************************************************
void Print_Str(uchar *s)
{
  while(*s != '\0')
    {
        Send_Byte(*s++);
        delay_ms(2);
    }
}

//*************************************************************************
//               Դ1Ľж
//*************************************************************************

#pragma vector=UART1RX_VECTOR
__interrupt void UART1_RX_ISR(void)
{
  uchar data=0;
  
  data=U1RXBUF;                       //յݴ
  Send_Byte(data);                    //յٷͳȥ
  delay_ms(5);                        //л֮ǰиСʱ
  RS485_CTR0;                         //л״̬
}

//*************************************************************************
//           
//*************************************************************************
void main(void)
{ 
  WDT_Init();                         //Ź
  Clock_Init();                       //ϵͳʱ
  Port_Init();                        //˿ڳʼ
  UART_Init();                        //óʼ
  Close_LED();                        //رʾ
  Print_Str("DM430-A Board UART Test\n"); //ַ
  RS485_CTR0;                         //л״̬
  _EINT();                            //ж
  while(1)                            //ѭ
    {
    }
}