//******************************************************************************
//DM430-ATFTɫҺʾģʱʾ
//ͨ㡢ߵȺнĻƣͨǶȶָƶ궨λ
//ʵʱʱͨȡDS1302ģʾ
//MSP430洢ݽṹΪСˣֽڵλַֽڸλַ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
//******************************************************************************

#include <msp430x14x.h>
#include "Config.h"
#include "DS1302.c"
#include "TFT.c"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


//***********************************************************************
//               ȫֱ
//***********************************************************************
uchar postion_x,postion_y;
uchar sxi,syi,mxi,myi,hxi,hyi;
uchar time_hour,time_min,time_sec;
uchar data_yearq,data_yearb,data_years,data_yearg,data_months,data_monthg,data_days,data_dayg;
uchar week,time_h;  			 //time_h绹־λ2Ϊ磬0Ϊ

extern uchar time_buf[8];                //ⲿ

//***********************************************************************
//               MSP430IOڳʼ
//***********************************************************************
void Port_Init()
{
  LED8SEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  LED8DIR  = 0xFF;                      //IOڷΪ
  LED8PORT = 0xFF;                      //P2ڳʼΪFF
  
  DATASEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  DATADIR  = 0xFF;                      //IOڷΪ
  DATAPORT = 0xFF;                      //P4ڳʼΪFF
  
  CTRSEL  =  0x00;                      //IOΪͨI/Oģʽ˾ʡ
  CTRDIR |=  BIT3 + BIT4;               //IOڷΪ,ƿP63,P64
  CTRPORT =  0xFF;                      //P6ڳʼΪFF  
 
  P6SEL = 0x00;                         //IOΪͨI/Oģʽ˾ʡ
  P6DIR |= BIT2;                        //P62Ϊ
  P6OUT = 0xFF;                         //P6ڳʼΪFF
  
  P4SEL = 0x00;
  P4DIR = 0xFF;                         //ݿģʽ
  P5SEL = 0x00;
  P5DIR|= BIT0 + BIT1+ BIT2 + BIT5 + BIT6 + BIT7;   //TFTƿΪģʽ
  
  LCD_BL0;                              //Һ⣬͵ƽ
}

//***********************************************************************
//         ʱӽ
//***********************************************************************                             
void GUIclock()
{
  GUIcircle(64,64,60,0x00ff);
  GUIfull(61,60,67,67,0xf800);          //ʱ
  GUIline(64,5,64,10,0x700); 	        //12ӷ
  GUIline(63,5,63,10,0x700); 	        //12ӷ
  GUIline(65,5,65,10,0x700); 	        //12ӷ
  GUIline(95,12,92,15,0x700); 	        //1ӷ
  GUIline(116,34,113,37,0x700); 	//2ӷ
  GUIline(123,64,118,64,0x700);  	//3ӷ
  GUIline(123,63,118,63,0x700);  	//3ӷ
  GUIline(123,65,118,65,0x700);  	//3ӷ
  GUIline(116,94,113,91,0x700); 	//4ӷ
  GUIline(95,116,92,113,0x700); 	//5ӷ
  GUIline(64,123,64,118,0x700);  	//6ӷ
  GUIline(63,123,63,118,0x700);  	//6ӷ
  GUIline(65,123,65,118,0x700);  	//6ӷ
  GUIline(34,116,37,113,0x700); 	//7ӷ
  GUIline(12,93,15,90,0x700);    	//8ӷ		
  GUIline(5,64,10,64,0x700);     	//9ӷ
  GUIline(5,63,10,63,0x700);     	//9ӷ
  GUIline(5,65,10,65,0x700);     	//9ӷ
  GUIline(12,34,15,37,0x700); 	        //10ӷ
  GUIline(34,12,37,15,0x700); 	        //11ӷ

 } 

//***********************************************************************
//         DS1302жȡʱݲ
//***********************************************************************
void TimeGet()
{
  time_hour=((time_buf[4]&0x1F) >> 4)*10+(time_buf[4] & 0x0F);	//Сʱ
  time_h=(time_buf[4] >> 4)&0x02;				//ж绹
  time_min=(time_buf[5] >> 4)*10+(time_buf[5] & 0x0F);	        //
  time_sec=(time_buf[6] >> 4)*10+(time_buf[6] & 0x0F);	        //
  data_yearq=(time_buf[0] >> 4);      		                //ݵǧλ
  data_yearb=(time_buf[0] & 0x0F);    		                //ݵİλ
  data_years=(time_buf[1] >> 4);      		                //ݵʮλ
  data_yearg=(time_buf[1] & 0x0F);                              //ݵĸλ
  data_months=(time_buf[2] >> 4);                               //ݵʮλ
  data_monthg=(time_buf[2] & 0x0F);			        //ݵĸλ
  data_days=(time_buf[3] >> 4);				        //ݵʮλ
  data_dayg=(time_buf[3] & 0x0F);				//ݵĸλ
  week=(time_buf[7] & 0x0F);					//
 }

//***********************************************************************
//         ʾں
//***********************************************************************
void DisplayData()
{
  DisplayChar(data_yearq+'0',0,9,0x0eee);
  DisplayChar(data_yearb+'0',1,9,0x0eee);
  DisplayChar(data_years+'0',2,9,0x0eee);
  DisplayChar(data_yearg+'0',3,9,0x0eee);
    
  DisplayChar('/',4,9,0x0eee);  				// "/"

  DisplayChar(data_months+'0',5,9,0x0eee);
  DisplayChar(data_monthg+'0',6,9,0x0eee);
  DisplayChar('/',7,9,0x0eee);  				// "/"
  
  DisplayChar(data_days+'0',8,9,0x0eee);
  DisplayChar(data_dayg+'0',9,9,0x0eee);
    
  DisplayGB2312(6,5,9,0x3fef);   				//
  DisplayGB2312(7,6,9,0x3fef);   				//
  DisplayGB2312(week+7,7,9,0x3fef);  			 	//ڼ
 }

//***********************************************************************
//              
//***********************************************************************
int main( void )
{ 
  WDT_Init();                                     //Ź
  Clock_Init();                                   //ϵͳʱ
  Port_Init();                                    //˿ڳʼ
  Close_LED();                                    //رʾ
  LCD_RD1; 
  LCD_Init();                                     //TFTʼ
  LCD_clear(0);                                   //
  
  DS1302_init();                        	  //DS1302ʼ
  delay_ms(10);
  DS1302_write_time();                 		  //DS1302дʼݣºʱ	 
  GUIclock();    			          //ʱӽ
	
  while(1)
  {
    delay_ms(900);
    DS1302_read_time();                	          //DS1302
    GUIline(64,64,sxi,syi,0);  			  //ָʾۼ
    TimeGet(); 
	
    if(time_h==0x02)
    {
      DisplayGB2312(16,3,5,0x079ff);              //
    }
    else
    {
      DisplayGB2312(15,3,5,0x79ff);  		  //
    }
    DisplayGB2312(17,4,5,0x79ff);  		  //
    DisplayData();

    if(time_sec==00)
    {
      hxi=(uchar)(64+cos(PI*0.5-PI*(time_hour)/6-PI*(time_min-1)/360)*30);  //Сʱݷӵı仯켣㹫ʽ
      hyi=(uchar)(64-sin(PI*0.5-PI*(time_hour)/6-PI*(time_min-1)/360)*30);  //Сʱݷӵı仯켣㹫ʽ
      GUIline(64,64,hxi,hyi,0);  				            //СʱָСʱºǰһۼ

      hxi=(uchar)(64+cos(PI*0.5-PI*(time_hour)/6-PI*time_min/360)*30);  	    
      hyi=(uchar)(64-sin(PI*0.5-PI*(time_hour)/6-PI*time_min/360)*30);
      GUIline(64,64,hxi,hyi,0x2ee0);  		                   //СʱָڷӸºʾµλ
    }
    else
    {
      hxi=(uchar)(64+cos(PI*0.5-PI*(time_hour)/6-PI*time_min/360)*30);
      hyi=(uchar)(64-sin(PI*0.5-PI*(time_hour)/6-PI*time_min/360)*30);
      GUIline(64,64,hxi,hyi,0x2ee0);  			          //СʱָڷӲʱʾԭλ
    }	

    if(time_sec==00)						  //ָºǰһۼ
    {
      mxi=(uchar)(64+cos(PI*0.5-PI*(time_min-1)/30)*40);				
      myi=(uchar)(64-sin(PI*0.5-PI*(time_min-1)/30)*40);
      GUIline(64,64,mxi,myi,0);  									
      mxi=(uchar)(64+cos(PI*0.5-PI*time_min/30)*40);
      myi=(uchar)(64-sin(PI*0.5-PI*time_min/30)*40);
      GUIline(64,64,mxi,myi,0x2e0);  				 //ָºʾµλ
    }
    else
    {
      mxi=(uchar)(64+cos(PI*0.5-PI*time_min/30)*40);	        //ӵı仯켣㹫ʽ
      myi=(uchar)(64-sin(PI*0.5-PI*time_min/30)*40);		//ӵı仯켣㹫ʽ
      GUIline(64,64,mxi,myi,0x2e0);  				//ָ벻ʱʾԭλ
    }
    sxi=(uchar)(64+cos(PI*0.5-PI*time_sec/30)*50);		//ָı仯켣㹫ʽ
    syi=(uchar)(64-sin(PI*0.5-PI*time_sec/30)*50);		//ָı仯켣㹫ʽ

    GUIline(64,64,sxi,syi,0xffe0);  		                //ʾָλ
    GUIfull(61,60,67,67,0xf800);   				//ʾʱ      
  }
}