/********************************************************************
//DM430-AͿʵʱʱDS1302Ƴʾռʱ
//ʾΪ1602Һһʾգڶʾʱ䣬Ϣδʾ
//ڿĬûдأ˶ϵʱϢᶪʧʼʱͨtime_buf
//Ҫڶϵ±֤ʱһŵذװĵͺ1220
//ʼʱΪBCDʽ
//װΪ֤ÿϵ粻ʼغDS1302_write_time()ĳ
//زDS1302_write_time()ĳ򣬱ÿεƬϵ类ʼҲͨúʵ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/
#include <msp430x14x.h>
#include "Config.h"

/*ʼʱ䣬BCDʽʱ2010-01-1409:55:00ڶ*/
unsigned char time_buf[8] = {0x20,0x10,0x01,0x14,0x09,0x55,0x00,0x02};

//*************************************************************************
//			ʼIOӳ
//*************************************************************************
void Port_Init()
{
  LED8SEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  LED8DIR  = 0xFF;                      //IOڷΪ
  LED8PORT = 0xFF;                      //P2ڳʼΪFF
  
  P4SEL = 0x00;
  P4DIR = 0xFF;                         //ݿģʽ
  P5SEL = 0x00;
  P5DIR|= BIT5 + BIT6 + BIT7;           //1602ҺƿΪģʽ
}

//***********************************************************************
//DS1302дһֽ
//***********************************************************************
void DS1302_write_byte(unsigned char addr, unsigned char d) 
{
  unsigned char i;
  RESET_SET;				//DS1302

/*дĿַaddr*/
  IO_OUT;
  addr = addr & 0xFE;                   //λ
  for (i = 0; i < 8; i ++) {
  if (addr & 0x01)
  {
    IO_SET;
  }
  else
  {
    IO_CLR;
  }
  SCK_SET;
  SCK_CLR;
  addr = addr >> 1;
}
/*дݣd*/
  IO_OUT;
  for (i = 0; i < 8; i ++) 
  {
    if (d & 0x01)
    {
      IO_SET;
    }
    else
    {
      IO_CLR;
    }
  SCK_SET;
  SCK_CLR;
  d = d >> 1;
  }
  RESET_CLR;				//ֹͣDS1302
}
//***********************************************************************
//                   DS1302һֽ
//***********************************************************************
unsigned char DS1302_read_byte(unsigned char addr)
{
  unsigned char i;
  unsigned char temp;
  RESET_SET;					//DS1302
/*дĿַaddr*/
  IO_OUT;
  addr = addr | 0x01;                             //λø
  for (i = 0; i < 8; i ++) 
  {
    if (addr & 0x01) 
    {
      IO_SET;
    }
    else 
    {
      IO_CLR;
    }
    SCK_SET;
    SCK_CLR;
    addr = addr >> 1;
  }
/*ݣtemp*/
  IO_IN;
  for (i = 0; i < 8; i ++)
  {
    temp = temp >> 1;
    if (IO_R)
    {
      temp |= 0x80;
    }
    else
    {
      temp &= 0x7F;
    }
  SCK_SET;
  SCK_CLR;
  }
  RESET_CLR;					//ֹͣDS1302
  return temp;
}

//***********************************************************************
//                   DS302дʱ
//***********************************************************************
void DS1302_write_time(void)
{

  DS1302_write_byte(DS1302_control_add,0x00);		//رд 
  DS1302_write_byte(DS1302_sec_add,0x80);	        //ͣ 
  //DS1302_write_byte(DS1302_charger_add,0xa9);		// 
  DS1302_write_byte(DS1302_year_add,time_buf[1]);	// 
  DS1302_write_byte(DS1302_month_add,time_buf[2]);	// 
  DS1302_write_byte(DS1302_date_add,time_buf[3]);	// 
  DS1302_write_byte(DS1302_day_add,time_buf[7]);	// 
  DS1302_write_byte(DS1302_hr_add,time_buf[4]);		//ʱ 
  DS1302_write_byte(DS1302_min_add,time_buf[5]);	//
  DS1302_write_byte(DS1302_sec_add,time_buf[6]);	//
  DS1302_write_byte(DS1302_day_add,time_buf[7]);	// 
  DS1302_write_byte(DS1302_control_add,0x80);		//д 
}

//***********************************************************************
//                     DS302ʱ
//***********************************************************************

void DS1302_read_time(void)  
{ 
  time_buf[1]=DS1302_read_byte(DS1302_year_add);	// 
  time_buf[2]=DS1302_read_byte(DS1302_month_add);	// 
  time_buf[3]=DS1302_read_byte(DS1302_date_add);	// 
  time_buf[4]=DS1302_read_byte(DS1302_hr_add);		//ʱ 
  time_buf[5]=DS1302_read_byte(DS1302_min_add);		// 
  time_buf[6]=(DS1302_read_byte(DS1302_sec_add))&0x7F;  // 
  time_buf[7]=DS1302_read_byte(DS1302_day_add);		// 
}

//***********************************************************************
//               DS302ʼ
//***********************************************************************
void DS1302_init(void) 
{
  RESET_CLR;			                        //RESETõ
  SCK_CLR;			                        //SCKõ
  RESET_OUT;			                        //RESETΪ
  SCK_OUT;			                        //SCKΪ
}

//***********************************************************************
//	ʾд뺯
//***********************************************************************
void LCD_write_com(unsigned char com) 
{	
  RS_CLR;
  RW_CLR;
  EN_SET;
  DataPort = com;
  delay_ms(5);
  EN_CLR;
}

//***********************************************************************
//	ʾд뺯
//***********************************************************************

void LCD_write_data(unsigned char data) 
{
  RS_SET;
  RW_CLR;
  EN_SET;
  DataPort = data;
  delay_ms(5);
  EN_CLR;
}
//***********************************************************************
//	ʾʾ
//***********************************************************************

void LCD_clear(void) 
{
  LCD_write_com(0x01);
  delay_ms(5);
}
//***********************************************************************
//	ʾַд뺯
//***********************************************************************

void LCD_write_str(unsigned char x,unsigned char y,unsigned char *s) 
{
  if (y == 0) 
  {
    LCD_write_com(0x80 + x);
  }
  else 
  {
    LCD_write_com(0xC0 + x);
  }  
  while (*s) 
  {
    LCD_write_data( *s);
    s ++;
  }
}

//***********************************************************************
//	ʾַд뺯
//***********************************************************************
void LCD_write_char(unsigned char x,unsigned char y,unsigned char data) 
{
  if (y == 0) 
  {
    LCD_write_com(0x80 + x);
  }
  else 
  {
    LCD_write_com(0xC0 + x);
  }
  LCD_write_data( data);  
}

//***********************************************************************
//	ʾʼ
//***********************************************************************
void LCD_init(void) 
{
  LCD_write_com(0x38);				//ʾģʽ
  delay_ms(5);
  LCD_write_com(0x08);				//ʾر
  delay_ms(5);
  LCD_write_com(0x01);				//ʾ
  delay_ms(5);
  LCD_write_com(0x06);				//ʾƶ
  delay_ms(5);
  LCD_write_com(0x0C);				//ʾ
  delay_ms(5);
}

//***********************************************************************
//	
//***********************************************************************
void main(void) 
{
  unsigned char temp;
  WDT_Init();                                   //Źʼ
  Clock_Init();                                 //ʱӳʼ
  Port_Init();                                  //˿ڳʼڿIO
  Close_LED();                                  //رLEDܣʾ
  delay_ms(200);
  LCD_init();                                   //1602Һʼ
  DS1302_init();                                //DS1302ʼ
  delay_ms(10);
  DS1302_write_time();                          //DS1302дʼݣºʱ
  while (1) 
  {
    delay_ms(200);
    DS1302_read_time();                         //DS1302		
    temp = (time_buf[0] >> 4) + '0';            //LCDдҪʾ
    LCD_write_char(0, 0, temp);/**/
    temp = (time_buf[0] & 0x0F) + '0';
    LCD_write_char(1, 0, temp);
    temp = (time_buf[1] >> 4) + '0';
    LCD_write_char(2, 0, temp);
    temp = (time_buf[1] & 0x0F) + '0';
    LCD_write_char(3, 0, temp);
    LCD_write_char(4, 0, '-');
		
    temp = (time_buf[2] >> 4) + '0';
    LCD_write_char(5, 0, temp);/**/
    temp = (time_buf[2] & 0x0F) + '0';
    LCD_write_char(6, 0, temp);
    LCD_write_char(7, 0, '-');
		
    temp = (time_buf[3] >> 4) + '0';
    LCD_write_char(8, 0, temp);/**/
    temp = (time_buf[3] & 0x0F) + '0';
    LCD_write_char(9, 0, temp);
		
    temp = (time_buf[4] >> 4) + '0';
    LCD_write_char(8, 1, temp);/*ʱ*/
    temp = (time_buf[4] & 0x0F) + '0';
    LCD_write_char(9, 1, temp);
    LCD_write_char(10, 1, ':');
		
    temp = (time_buf[5] >> 4) + '0';
    LCD_write_char(11, 1, temp);/**/
    temp = (time_buf[5] & 0x0F) + '0';  
    LCD_write_char(12, 1, temp);
    LCD_write_char(13, 1, ':');
		  
    temp = (time_buf[6] >> 4) + '0';
    LCD_write_char(14, 1, temp);/**/
    temp = (time_buf[6] & 0x0F) + '0';
    LCD_write_char(15, 1, temp);
  }
}
