/********************************************************************
//I2CͨغܽŽӿĿļConfig.hļ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/

/********************************************************************
ƣstart
    ܣI2Cʼ
    
ֵ  
********************************************************************/
void start(void)
{
	SCL_H;
	SDA_H;
	delay_us(5);
	SDA_L;
	delay_us(5);
	SCL_L;
	delay_us(5);
}
/********************************************************************
ƣstop
    ܣI2Cֹ
    
ֵ  
********************************************************************/
void stop(void)
{
	SDA_L;
	delay_us(5);
	SCL_H;
	delay_us(5);
	SDA_H;
	delay_us(5);	   
}
/********************************************************************
ƣmack
    ܣI2CӦ
    
ֵ  
********************************************************************/
void mack(void)
{
	SDA_L;
	_NOP(); _NOP();
	SCL_H;
	delay_us(5);
	SCL_L;
	_NOP();_NOP();
	SDA_H;     
	delay_us(5);
}
/********************************************************************
ƣmnack
    ܣI2CӦ
    
ֵ  
********************************************************************/
void mnack(void)
{
	SDA_H;
	_NOP(); _NOP();
	SCL_H;
	delay_us(5);
	SCL_L;
	_NOP(); _NOP();
	SDA_L;   
	delay_us(5);       
}

/********************************************************************
ƣcheck
    ܣӻӦ
    
ֵ  ӻǷӦ1--У0--
********************************************************************/
uchar check(void)
{
	uchar slaveack;
    
	SDA_H;
	_NOP(); _NOP();
	SCL_H;
	_NOP(); _NOP();
        SDA_IN;
        _NOP(); _NOP();
	slaveack = SDA_VAL;                     //SDAֵ
	SCL_L;
	delay_us(5);
        SDA_OUT;
        if(slaveack)    return FALSE;
        else            return TRUE;
}

/********************************************************************
ƣwrite1
    ܣI2C߷һ1
    
ֵ  
********************************************************************/
void write1(void)
{
	SDA_H;
	delay_us(5);
	SCL_H;
	delay_us(5);
	SCL_L;				
	delay_us(5);
}
/********************************************************************
ƣwrite0
    ܣI2C߷һ0
    
ֵ  
********************************************************************/
void write0(void)
{
	SDA_L;
	delay_us(5);
	SCL_H;
	delay_us(5);			 
	SCL_L;				
	delay_us(5);
}
/********************************************************************
ƣwrite1byte
    ܣI2C߷һֽڵ
    WriteData--͵
ֵ  
********************************************************************/
void write1byte(uchar WriteData)
{
	uchar i;
    
	for(i = 8;i > 0;i--)
	{
	  if(WriteData & 0x80)	write1();
	  else 		        write0();
	  WriteData <<= 1;
	}                  
	
	SDA_H;
	_NOP();   
}
/********************************************************************
ƣwriteNbyte
    ܣI2C߷Nֽڵ
    outbuffer--ָݴ׵ַ
          ָ
          n--ݵĸ
ֵ  Ƿɹı־1--ɹ0--ʧ
********************************************************************/
uchar writeNbyte(uchar * outbuffer,uchar n)
{
	uchar i;
    
	for(i = 0;i < n;i++)
	{
		write1byte(* outbuffer);
		if(check())      
		{
		  outbuffer++;			
		}
		else 
		{
		  stop();
		  return FALSE;
		}
	}

	stop();
	return TRUE;			
}
/********************************************************************
ƣread1byte
    ܣI2C߶ȡһֽ
    
ֵ  ȡ
********************************************************************/
uchar read1byte(void)
{
	uchar  ReadData = 0x00,i;
        uchar flag;
    
	for(i = 0;i < 8;i++)
	{
	  SDA_H;
	  delay_us(5);
	  SCL_H;
          SDA_IN;
	  delay_us(5);
	  flag = SDA_VAL;
	  ReadData <<= 1;
	  if(flag)	ReadData |= 0x01;
          SDA_OUT;
	  SCL_L;
	  delay_us(5);
	}

	return ReadData;
}
/********************************************************************
ƣreadNbyte
    ܣI2C߶ȡNֽڵ
    inbuffer--ȡݴŵ׵ַ
          n--ݵĸ
ֵ  
********************************************************************/
void readNbyte(uchar * inbuffer,uchar n)
{
	uchar i;
    
	for(i = 0;i < n;i++)
	{
	  inbuffer[i] = read1byte();
	  if(i < (n-1))	mack();
	  else            mnack();
	}
	 
	stop();
}
