/********************************************************************
//DM430-AͿEEPROMдʵ飬EEPROMͺΪ24C16
//ǰλʾдֵλʾȡֵдȡʧܣλΪ0
//ܿƲ74HC573ƣö̬ʾƣúλʾ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/

#include <msp430x14x.h>
#include "Config.h"                  //ͷļҪIO˿Ϣ
#include "I2C.c"                     //I2Cģⷽʽ
#include "EEPROM.c"                  //EEPROMдز

uchar WriteBuffer[] = {1,2,3,4};     //׼дEEPROMݣ4ֽ
uchar ReadBuffer[4] = {0,0,0,0};     //ݻŶȡ    
uchar Flag = 0;                      //־λǷɹ

//***********************************************************************
//               MSP430IOڳʼ
//***********************************************************************
void Port_Init()
{
  LED8SEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  LED8DIR  = 0xFF;                      //IOڷΪ
  LED8PORT = 0xFF;                      //P2ڳʼΪFF
  
  DATASEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  DATADIR  = 0xFF;                      //IOڷΪ
  DATAPORT = 0xFF;                      //P4ڳʼΪFF
  
  CTRSEL  =  0x00;                      //IOΪͨI/Oģʽ˾ʡ
  CTRDIR |=  BIT3 + BIT4;               //IOڷΪ,ƿP63,P64
  CTRPORT =  0xFF;                      //P6ڳʼΪFF  
  
  P2DIR |= BIT5 + BIT6;                 //24C16Ӷ˿Ϊ״̬
}

//***********************************************************************
//		ʾEEPROM
//***********************************************************************

void DisplayEEPROM()
{
   uchar i,j;
   j=0x01;                            //λѡ
  for(i=0;i<4;i++)
  {
    DCTR1;                            //ܶݵ74HC573LEܽø
    WCTR1;                            //λ74HC573LEܽø
    DATAPORT=~j;                      //ҪʾλҲһ
    WCTR0;                            //λݣ϶Ժ󣬾ʾ                          
    DATAPORT=table[WriteBuffer[i]];   //ҪʾݣǶݣʾ0͵0x3f
    DCTR0;                            //ݣһʱƬ
    j=j<<1;                           //λ׼һλʾ
    delay_ms(1);                      //ʾһʱƬ̣ӰȺ˸
  }
  
  for(i=4;i<8;i++)
  {
    DCTR1;                            //ܶݵ74HC573LEܽø
    WCTR1;                            //λ74HC573LEܽø
    DATAPORT=~j;                      //ҪʾλҲһ
    WCTR0;                            //λݣ϶Ժ󣬾ʾ                          
    DATAPORT=table[ReadBuffer[i-4]];  //ҪʾݣǶݣʾ0͵0x3f
    DCTR0;                            //ݣһʱƬ
    j=j<<1;                           //λ׼һλʾ
    delay_ms(1);                      //ʾһʱƬ̣ӰȺ˸
  }
}

//***********************************************************************
//            
//***********************************************************************
void main(void)
{   
  WDT_Init();                         //Źʼ
  Clock_Init();                       //ʱӳʼ
  Port_Init();                        //˿ڳʼڿIO
  Close_LED();                        //LEDȹر
    
  if(Write_1Byte(0x11,0x00))          //ڵַ0x00д0x11
    Flag = 1;
  _NOP();                             //зڴöϵ۲flag
  
  if(Read_1Byte_Randomaddress(0x00) == 0x11)
    Flag = 2;
  _NOP();                             //ȡһֽ
  
  if(Write_NByte(WriteBuffer,4,0x08)) //ӵ1ҳĵ0ֽд4
  {
    DisplayEEPROM();                  //дɹʾ
  }
  
  if(Read_NByte_Randomaddress(ReadBuffer,4,0x08))//ӵ1ҳĵ0ֽ4
  {
    DisplayEEPROM();                  //дɹʾ
  }

  Flag += 0;                          //˾Ϊ뾯棬ʵ
  while(1)
  {
    DisplayEEPROM();                  //ʾݣǰ4λдģ4λǶ
  }
}