#define CPU_F ((double)8000000) 
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0)) 
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0)) 

#define uchar unsigned char
#define uint  unsigned int
#define ulong unsigned long

/*BRCLK=CPU_FʱĹʽԼ㣬ҪüƵϵ*/
#define baud           9600                                //òʵĴС
#define baud_setting   (uint)((ulong)CPU_F/((ulong)baud))  //ʼ㹫ʽ
#define baud_h         (uchar)(baud_setting>>8)            //ȡλ
#define baud_l         (uchar)(baud_setting)               //λ

#define LED8PORT        P2OUT                   //P28LED
#define LED8SEL         P2SEL                   //P28LED
#define LED8DIR         P2DIR                   //P28LED

#define DATAPORT	P4OUT                   //ݿڶ˿P4
#define DATASEL         P4SEL                   //ݿڹܼĴƹģʽ
#define DATADIR         P4DIR                   //ݿڷĴ

#define CTRPORT	        P6OUT                   //ڵĶ˿P6
#define CTRSEL          P6SEL                   //ƿڹܼĴƹģʽ
#define CTRDIR          P6DIR                   //ƿڷĴ

#define DCTR0	        P6OUT &= ~BIT4          //ܶολźõ
#define DCTR1           P6OUT |=  BIT4          //ܶολźø
#define WCTR0	        P6OUT &= ~BIT3          //λλźõ
#define WCTR1           P6OUT |=  BIT3          //λλźø

#define KEYPORT	        P1OUT                   //ڵĶ˿P1
#define KEYSEL          P1SEL                   //ƿڹܼĴƹģʽ
#define KEYDIR          P1DIR                   //ƿڷĴ
#define KEYIN           P1IN                    //ɨжҪȡIO״ֵ̬

#define DACCS0          P5OUT &= ~BIT4          //DACƬѡźõ
#define DACCS1          P5OUT |=  BIT4          //DACƬѡźø
#define DIN0            P3OUT &= ~BIT1          //DAC DINܽλΪ0
#define DIN1            P3OUT |=  BIT1          //DAC DINܽλΪ1
#define DOUT0           P3OUT &= ~BIT2          //DAC DOUTܽλΪ0
#define DOUT1           P3OUT |=  BIT2          //DAC DOUTܽλΪ0
#define SCLK0           P3OUT &= ~BIT3          //DAC SCLKܽλΪ0
#define SCLK1           P3OUT |=  BIT3          //DAC SCLKܽλΪ0

#define SOUNDON         P6OUT &= ~BIT2          //
#define SOUNDOFF        P6OUT |=  BIT2          //

uchar   key=0xFF;                               //ֵ

//***********************************************************************
//			ʾĶ
//***********************************************************************

uchar table[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,
               0x7f,0x6f,0x77,0x7c,0x39,0x5e,0x79,0x71};

//***********************************************************************
//                   ϵͳʱӳʼ
//***********************************************************************
void Clock_Init()
{
  uchar i;
  BCSCTL1&=~XT2OFF;                 //XT2
  BCSCTL2|=SELM1+SELS;              //MCLKΪ8MHZSMCLKΪ8MHZ
  do{
    IFG1&=~OFIFG;                   //־
    for(i=0;i<100;i++)
       _NOP();
  }
  while((IFG1&OFIFG)!=0);           //־λ1ѭȴ
  IFG1&=~OFIFG; 
}
//***********************************************************************
//               MSP430ڲŹʼ
//***********************************************************************
void WDT_Init()
{
   WDTCTL = WDTPW + WDTHOLD;       //رտŹ
}

//***********************************************************************
//		ر
//***********************************************************************
void Close_LED()
{
  DATASEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  DATADIR  = 0xFF;                      //IOڷΪ
  DATAPORT = 0xFF;                      //P4ڳʼΪFF
  
  CTRSEL  =  0x00;                      //IOΪͨI/Oģʽ˾ʡ
  CTRDIR |=  BIT3 + BIT4;               //IOڷΪ,ƿP63,P64
  CTRPORT =  0xFF;                      //P6ڳʼΪFF  
  
  DCTR1;                                //صܣʾ                   
  WCTR1;                     
  DATAPORT=0xFF;                        //            
  WCTR0; 
}