//******************************************************************************
//MMC/SDSPIģʽMMC/SDʶMMC/SD
//MMC/SDMSP430F149SPIӿڣͼοDM430-Aԭͼ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
//******************************************************************************  

#ifndef _MMCLIB_C
#define _MMCLIB_C

#include "mmc.h"                            //SDͷļҪCSƬѡźţӲ
#include "MSP430x14x.H"                     //ͷļ

/***********************************************************************
                    
***********************************************************************/
char mmc_buffer[512] = { 0 };               // Buffer for mmc i/o for data and registers

/***********************************************************************
ܣMMC/SDʼ
ݣ1CSƬѡMOSI74ʱ
          2SPI10FF
***********************************************************************/
uchar initMMC (void)
{
  int i;
  
  initSPI();
  CS_HIGH();
  for(i=0;i<=9;i++)
    spiSendByte(0xff);

  return (mmc_GoIdle());
}

/***********************************************************************
ܣMMC/SDģʽʼ
ݣ1ʼMMC/SDSPIģʽMMCSDCMD0
          2жMMCSD
          3SDѭ10ηCMD55+ACMD41MMCCMD1
***********************************************************************/
char mmc_GoIdle()
{
  char response=0x01;
  unsigned char i;
  unsigned char sdcard=0x00;               //SD־λΪ0ʾSDΪ1ʾΪMMC
  CS_LOW();                                //ѡMMC/SDƬѡЧ
  mmcSendCmd(MMC_GO_IDLE_STATE,0,0x95);    //CMD0MMC/SDΪSPIģʽ0x95ΪCRCֵ
  //Now wait for READY RESPONSE
  if(mmcGetResponse()!=0x01)
    return MMC_INIT_ERROR;

  while(response==0x01)
  {
    CS_HIGH();
    spiSendByte(0xff);
    CS_LOW();
  if(sdcard==0x00)                                //ʶǷΪSDSDCMD55+ACMD41
  {
   for(i=0;i<10;i++)                              //ѭ10ΣΪSDһ2μȷ0x00
   {
    mmcSendCmd(SD_APP_COND,0x00,0xff);            //SDжɹ0x00ΪSD
    while(response=mmcGetResponse()!=0x01);       //ֵΪ0x01ʾڿ״̬ٷACMD41
    
    mmcSendCmd(SD_APP_OP_COND,0x00,0xff);         //ACMD41
    if(response=mmcGetResponse()==0x00)           //ֵΪ0x00ʼɹʹMMCCMD1ʼ
     {
      CS_HIGH();
      spiSendByte(0xff);
      return (MMC_SUCCESS);                       //سʼɹ
     }
   }
   sdcard=0x01;                                   //Ϊ1ʾSDЧΪMMC׼淢CMD1
  }
    response=0x01;                                //׼MMCCMD1
    mmcSendCmd(MMC_SEND_OP_COND,0x00,0xff);       //MMCCMD1ɹ򷵻0x00
    response=mmcGetResponse();                    //ֵΪ0x00ʾMMCʼɹ
  }
  
  CS_HIGH();                                      //MMC/SDƬѡЧ
  spiSendByte(0xff);
  return (MMC_SUCCESS);                           //سʼɹ
}

/***********************************************************************
ܣMMC/SDӦֵȡ
ݣ1SPIģʽӦֵ1~8bytesοSDֲӦֵ
          2ӦֵλΪ0Ϊ
          3ӦֵΪFFʾЧʱ
***********************************************************************/
uchar mmcGetResponse(void)
{
  int i=0;
  char response;

  while(i<=64)
  {
    response=spiSendByte(0xff);
    if(response==0x00)break;
    if(response==0x01)break;
    i++;
  }
  return response;
}

/***********************************************************************
ܣMMC/SDͶд󷵻صӦֵ
ݣ1SPIģʽӦֵ1~8bytesοSDֲӦֵ
          2ӦֵλΪ0Ϊ
          3Ӧ֮ǰһֱΪ0xff
***********************************************************************/
uchar mmcGetXXResponse(const char resp)
{
  int i=0;
  char response;

  while(i<=1000)
  {
    response=spiSendByte(0xff);
    if(response==resp)break;
    i++;
  }
  return response;
}

/***********************************************************************
ܣMMC/SDæ
ݣ1SPIģʽӦֵ1~8bytesοSDֲӦֵ
          2ӦֵλΪ0Ϊ
          3ӦֵΪFFʾЧʱ
          4ݿдʱдݺ󶼻Ӧֵ˴
***********************************************************************/
uchar mmcCheckBusy(void)
{

  int i=0;

  char response;
  char rvalue;
  while(i<=64)
  {
    response=spiSendByte(0xff);
    response &= 0x1f;
    switch(response)
    {
      case 0x05: rvalue=MMC_SUCCESS;break;      //ʾMMC/SDȷɹ
      case 0x0b: return(MMC_CRC_ERROR);         //ʾCRCУݱܾ
      case 0x0d: return(MMC_WRITE_ERROR);       //ʾMMC/SDдݱܾ
      default:
        rvalue = MMC_OTHER_ERROR;               //
        break;
    }
    if(rvalue==MMC_SUCCESS)break;
    i++;
  }
  i=0;
  do
  {
    response=spiSendByte(0xff);
    i++;
  }while(response==0);
  return response;
}

/***********************************************************************
ܣMMC/SDݶȡ
ݣ1ȡĵַԼĻ
		  2СãΪ512Ϊһ׼С
          3ݺ16λCRCֵ
***********************************************************************/
uchar mmcReadBlock(ulong address, uint count, uchar *pBuffer)
{
  unsigned long i = 0;
  uchar rvalue = MMC_RESPONSE_ERROR;

  if (mmcSetBlockLength (count) == MMC_SUCCESS)  //MMC/SD鳤,ȫֱBlockLength
  {

    CS_LOW ();

    mmcSendCmd (MMC_READ_SINGLE_BLOCK,address, 0xFF); //ͶCMD17ʵʵַnumSector*512
    if (mmcGetResponse() == 0x00)                         //ֵΪ00ʾɹ
    {
      if (mmcGetXXResponse(MMC_START_DATA_BLOCK_TOKEN) == MMC_START_DATA_BLOCK_TOKEN) //ݰʼ־Ϊ0xfe
      {
        for (i = 0; i < count; i++)
          pBuffer[i] = spiSendByte(0xff);   // ն

        spiSendByte(0xff);                  //16λCRCֵ
        spiSendByte(0xff);                  //16λCRCֵCRCֵԣʵݺ16λCRCֵ
        rvalue = MMC_SUCCESS;               //ճɹسɹ
      }
      else
      {
        rvalue = MMC_DATA_TOKEN_ERROR;      // ûյݰĿʼ־򷵻ش
      }
    }
    else
    {
      rvalue = MMC_RESPONSE_ERROR;          //δɹմ
    }
  }
  else
  {
    rvalue = MMC_BLOCK_SET_ERROR;           //ؿ鳤ʧܴ
  }
  CS_HIGH ();
  spiSendByte(0xff);
  return rvalue;                            //ضȡ
}

/***********************************************************************
ܣMMC/SDд
ݣ1ȡĵַԼĻ
		  2СãΪ512Ϊһ׼С
          3ݺ16λCRCֵ
***********************************************************************/
uchar mmcWriteBlock(ulong address, uint count, uchar *pBuffer)
{
  unsigned long i = 0;
  uchar rvalue = MMC_RESPONSE_ERROR;         

  if (mmcSetBlockLength (count) == MMC_SUCCESS)    //MMC/SDĳȣȫֱBlockLength
  {
    CS_LOW ();									   //ƬѡźţѡҪƬѡ
    mmcSendCmd (MMC_WRITE_BLOCK,address, 0xFF);//͵дCMD24ַΪnumSector*512

    if (mmcGetXXResponse(MMC_R1_RESPONSE) == MMC_R1_RESPONSE) //յֵMMC/SDǷȷ
    {
      spiSendByte(0xff);
      spiSendByte(0xfe);                           //ʼ־0xfeʾݰһ鳤ȵ

      for (i = 0; i < count; i++)                  //дһ鳤ȵݵMMC/SD
        spiSendByte(pBuffer[i]);            

      spiSendByte(0xff);                           //16λCRCֵǱģԲЩʵCRCֵ
      spiSendByte(0xff);
      mmcCheckBusy();                              //MMC/SDæزοӦﲻȡ
      rvalue = MMC_SUCCESS;                        //ɹ
    }
    else
    {
      rvalue = MMC_RESPONSE_ERROR;   	           //ʧܣش
    }
  }
  else
  {
    rvalue = MMC_BLOCK_SET_ERROR;                  //ÿ鳤ʧܣش
  }

  CS_HIGH ();                                      //ƬѡͷSD
  spiSendByte(0xff);                               //Сʱ
  return rvalue;                                   //״ֵ̬
} 

/***********************************************************************
ܣMMC/SDͺ
ݣ1Ϊ48λMMC/SD
		  2ʵ6λ48λлĲͬͬ
***********************************************************************/
void mmcSendCmd (uchar cmd, ulong data, uchar crc)
{
  uchar frame[6];                                  //MMC/SDΪ48λ,6ֽ
  uchar temp;
  int i;
  frame[0]=(cmd|0x40);                             //ʽߵλΪ01ڵֽ˵""0x40
  for(i=3;i>=0;i--)                                //4ֽڳȵĲûУΪַͬ²ͬ
  	{
    	temp=(uchar)(data>>(8*i));
    	frame[4-i]=(temp);
  	}
  frame[5]=(crc);                                  //1ֽڵCRCֵ
  for(i=0;i<6;i++)
    	spiSendByte(frame[i]);                     //
}

/**********************************************************************
ܣMMC/SD鳤
ݣ1ÿ鳤ȣΪ2^nСһΪ512
		  2RAMСĵƬԶСĿ鳤ȣʡݿռ
***********************************************************************/
uchar mmcSetBlockLength (uint blocklength)
{

  CS_LOW ();                                       //ѡSDƬѡź
  mmcSendCmd(MMC_SET_BLOCKLEN, blocklength, 0xFF); //ÿ鳤CMD16
  if(mmcGetResponse()!=0x00)                       //Ͳɹ¸λMMC/SDȻ
  	{ 
  		initMMC();
    	mmcSendCmd(MMC_SET_BLOCKLEN, blocklength, 0xFF);
    	mmcGetResponse();
  	}

  CS_HIGH ();                                      //ͷMMC/SD
 
  spiSendByte(0xff);                               //8ʱӵʱ

  return MMC_SUCCESS;                              //زɹ
} 

/**********************************************************************
ܣCSDCIDĴֵ
ݣ1CSDCIDĴ¼˿Ϣ
		  2ͨCSDȡ
***********************************************************************/
uchar mmcReadRegister (uchar cmd_register, uchar length, uchar *pBuffer)
{
  uchar i = 0;
  uchar rvalue = MMC_TIMEOUT_ERROR;

  if (mmcSetBlockLength (length) == MMC_SUCCESS)   //ÿ鳤
  {
    CS_LOW ();

    mmcSendCmd(cmd_register, 0x00, 0xff);          //ͶԼĴ

    if (mmcGetResponse() == 0x00)                  //سɹ
    {
      if (mmcGetXXResponse(MMC_START_DATA_BLOCK_TOKEN)==MMC_START_DATA_BLOCK_TOKEN) //ʼ־λ0xfe
        for (i = 0; i < length; i++)
          pBuffer[i] = spiSendByte(0xff);          //ȡݣĴֵ
      spiSendByte(0xff);                           //16λCRCֵǱ
      spiSendByte(0xff);
      rvalue = MMC_SUCCESS;                        //سɹ
    }
    else
      rvalue = MMC_RESPONSE_ERROR;                 //ɹش

    CS_HIGH ();                                    //ͷMMC/SD

    spiSendByte(0xff);			           //ʱ8ʱ
  }
  CS_HIGH ();                                      //ͷMMC/SD
  return rvalue;                                   //״ֵ̬
} 

/**********************************************************************
ܣMMC/SDȡ
ݣ1ȻȡCSDĴ
		  2㹫ʽȡС
		  3СΪûʹÿռС
***********************************************************************/
ulong MMC_ReadCardSize(void)
{

  ulong MMC_CardSize;
  uint i, j,b,response,mmc_C_SIZE=0;     

  uchar mmc_READ_BL_LEN=0;         		   //С
  uchar mmc_C_SIZE_MULT=0;         		   //С

  CS_LOW ();
  
  mmcSendCmd(MMC_READ_CSD, 0x00, 0xff);	          //ͶȡCSDĴCMD9

  response = mmcGetResponse();

  b = spiSendByte(0xFF);                          //ȡֵݿʼ־0xfe

  if( !response )
  {
    while (b != 0xfe) b = spiSendByte(0xff);      //ȴյʼ־λ

    for(j=5; j>0; j--)                            //ǰ5ֽڵݲãBit[127:88]
      b = spiSendByte(0xff);

    b =spiSendByte(0xff);                         
    mmc_READ_BL_LEN = b & 0x0F;                   //Bit[83:80]¼˿СοCSDĴ˵

    b = spiSendByte(0xff);

    mmc_C_SIZE = (b & 0x03) << 10;               //Bit[73:62]¼C_SIZEĴСοCSDĴ˵
    b = spiSendByte(0xff);
    mmc_C_SIZE += b << 2;
    b = spiSendByte(0xff);
    mmc_C_SIZE += b >> 6;

    b = spiSendByte(0xff);


    mmc_C_SIZE_MULT = (b & 0x03) << 1;           //Bit[49:47]¼˳ĴС
    b = spiSendByte(0xff);
    mmc_C_SIZE_MULT += b >> 7;


    b = spiSendByte(0xff);                       //֮޹

    b = spiSendByte(0xff);

    b = spiSendByte(0xff);

    b = spiSendByte(0xff);

    b = spiSendByte(0xff);

  }

  for(j=4; j>0; j--)          			// ٱ32ʱڵSCK
    b = spiSendByte(0xff);  					 
                               					
  b = spiSendByte(0xff);
  CS_LOW ();

  MMC_CardSize = (mmc_C_SIZE + 1);              //㣬ο㹫ʽ

  for(i = 2,j=mmc_C_SIZE_MULT+2; j>1; j--)      //С鳤ȡһ㱣ΪܴС1%
    i <<= 1;
  MMC_CardSize *= i;

  for(i = 2,j=mmc_READ_BL_LEN; j>1; j--)
    i <<= 1;
  MMC_CardSize *= i;

  return (MMC_CardSize);                        //ֵСλΪֽ

}
/*************************************************
ܣMMC/SDǷ
ݣ1MMC/SDδ룬6ߵƽ(Ե)
          2ģݲ֧Ӳ
*************************************************/
char mmc_ping(void)
{
  if (!(P5IN & 0x01))
    return (MMC_SUCCESS);
  else
    return (MMC_INIT_ERROR);
}


#ifdef withDMA
#ifdef __IAR_SYSTEMS_ICC__
#if __VER__ < 200
interrupt[DACDMA_VECTOR] void DMA_isr(void)
#else
#pragma vector = DACDMA_VECTOR
__interrupt void DMA_isr(void)
#endif
#endif

#ifdef __CROSSWORKS__
void DMA_isr(void)   __interrupt[DACDMA_VECTOR]
#endif

#ifdef __TI_COMPILER_VERSION__
__interrupt void DMA_isr(void);
DMA_ISR(DMA_isr)
__interrupt void DMA_isr(void)
#endif
{
  DMA0CTL &= ~(DMAIFG);
  LPM3_EXIT;
}
#endif

#endif /* _MMCLIB_C */
