/********************************************************************
//DM430-Aƴֿ12864ҺģʾԳʾַ
//ʾģʽΪģʽֱӽ1286412864ӿڼɣ⣬Һλ
//עѡҺĵԴλڵλѡ5V3.3VҺѹѡ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/
#include <msp430x14x.h>
#include "Config.h"

//*************************************************************************
//			ʼIOӳ
//*************************************************************************
void Port_Init()
{
  P4SEL = 0x00;
  P4DIR = 0xFF;
  P5SEL = 0x00;
  P5DIR|= BIT0 + BIT1 + BIT5 + BIT6 + BIT7;
  PSB_SET;		  //Һڷʽ
  RST_SET;		  //λRSTø
}

//***********************************************************************
//	ʾд뺯
//***********************************************************************
void LCD_write_com(unsigned char com) 
{	
  RS_CLR;
  RW_CLR;
  EN_SET;
  DataPort = com;
  delay_ms(5);
  EN_CLR;
}

//***********************************************************************
//	ʾд뺯
//***********************************************************************
void LCD_write_data(unsigned char data) 
{
  RS_SET;
  RW_CLR;
  EN_SET;
  DataPort = data;
  delay_ms(5);
  EN_CLR;
}

//***********************************************************************
//	ʾʾ
//***********************************************************************

void LCD_clear(void) 
{
  LCD_write_com(0x01);
  delay_ms(5);
}

//***********************************************************************
//ƣDisplayCgrom(uchar hz)ʾCGROMĺ
//***********************************************************************
void DisplayCgrom(uchar addr,uchar *hz)
{
  LCD_write_com(addr);
  delay_ms(5);
  while(*hz != '\0')  
  {
    LCD_write_data(*hz);
    hz++;
    delay_ms(5);
  }

} 

//****************************************************************
//ƣDisplay()ʾԽ
//****************************************************************
void Display(void)
{
  DisplayCgrom(0x80,"͵ӻӭ");
  DisplayCgrom(0x88,":jingyehanxing");
  DisplayCgrom(0x90,"www.avrgcc.com  ");
  DisplayCgrom(0x98,"绰057487470625");
}

//***********************************************************************
//	ʾʼ
//***********************************************************************
void LCD_init(void) 
{
  LCD_write_com(FUN_MODE);			//ʾģʽ
  delay_ms(5);
  LCD_write_com(FUN_MODE);			//ʾģʽ
  delay_ms(5);
  LCD_write_com(DISPLAY_ON);			//ʾ
  delay_ms(5);
  LCD_write_com(CLEAR_SCREEN);			//
  delay_ms(5);
}

//***********************************************************************
//      
//***********************************************************************
void main(void)
{
  WDT_Init();                                   //Ź
  Clock_Init();                                 //ϵͳʱ
  Port_Init();                                  //ϵͳʼIO
  Close_LED();                                  //رLEDܣʾ
  delay_ms(100);                                //ʱ100ms
  LCD_init();                                   //Һʼ
  LCD_clear();                                  //
  while(1)
  {
    Display();                                  //ʾ
  }
}