//*************************************************************************************
//MMC/SDдͷļmmc.h
//SDӲӡ궨MMC/SDдش(ɹ롢)
//ӲӲͬԸĶ˿
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
// *************************************************************************************

/**********************************************************************
              MMC/SDӲIOڷ
***********************************************************************/

#define HIGH(a) ((a>>8)&0xFF)                     //ȡһݵĸֽڲ
#define LOW(a)  (a&0xFF)                          //ȡһݵĵֽڲ

#define CS_LOW()    P3OUT &= ~BIT0                //MMC/SDƬѡźõͣѡ״̬
#define CS_HIGH()   SPI_TX_DONE; P3OUT |= BIT0    //MMC/SDƬѡźøߣЧ״̬
#define SPI_RXC     (IFG1 & URXIFG0)
#define SPI_TXC     (IFG1 & UTXIFG0)

#define SPI_RX_COMPLETE (IFG1 & URXIFG0)
#define SPI_TX_READY    (IFG1 & UTXIFG0)
#define SPI_TX_DONE     while((U0TCTL & TXEPT)==0)


/**********************************************************************
             ݴ俪ʼ־Ҫڶݺдǰм
***********************************************************************/

#define MMC_START_DATA_BLOCK_TOKEN          0xfe   //ݴ俪ʼ־λʼ
#define MMC_START_DATA_MULTIPLE_BLOCK_READ  0xfe   //ݴ俪ʼ־λʼ
#define MMC_START_DATA_BLOCK_WRITE          0xfe   //ݴ俪ʼ־λʼд
#define MMC_START_DATA_MULTIPLE_BLOCK_WRITE 0xfc   //ݴ俪ʼ־λʼд
#define MMC_STOP_DATA_MULTIPLE_BLOCK_WRITE  0xfd   //ݴֹͣ־λֹͣд

// an affirmative R1 response (no errors)
#define MMC_R1_RESPONSE       0x00

/**********************************************************************
             سɹ
***********************************************************************/

#define MMC_SUCCESS           0x00           //ִгɹ
#define MMC_BLOCK_SET_ERROR   0x01           //ûȫ뵽
#define MMC_RESPONSE_ERROR    0x02
#define MMC_DATA_TOKEN_ERROR  0x03
#define MMC_INIT_ERROR        0x04
#define MMC_CRC_ERROR         0x10
#define MMC_WRITE_ERROR       0x11
#define MMC_OTHER_ERROR       0x12
#define MMC_TIMEOUT_ERROR     0xFF

/**********************************************************************
              MMC/SD
***********************************************************************/

#define MMC_GO_IDLE_STATE          0x40     //CMD0 MMC/SDϵģʽ
#define MMC_SEND_OP_COND           0x41     //CMD1 MMCʼʹCMD1жSDMMC
#define MMC_CID                    0x48     //CMD8 SD汾жϢVer1.xVer2.xCMD8ӦΪVer1.x
#define MMC_READ_CSD               0x49     //CMD9 ȡϢVer1.xֻ֧2GBVer2.xָ֧
#define MMC_SEND_CID               0x4a     //CMD10 MMC/SDϢIDڵȵȣǱ
#define MMC_STOP_TRANSMISSION      0x4c     //CMD12 ʱֹͣ
#define MMC_SEND_STATUS            0x4d     //CMD13 ״̬ȡ
#define MMC_SET_BLOCKLEN           0x50     //CMD16 öдĳ
#define MMC_READ_SINGLE_BLOCK      0x51     //CMD17 
#define MMC_READ_MULTIPLE_BLOCK    0x52     //CMD18 
#define MMC_CMD_WRITEBLOCK         0x54     //CMD20 
#define MMC_WRITE_BLOCK            0x58     //CMD24 д
#define MMC_WRITE_MULTIPLE_BLOCK   0x59     //CMD25
#define MMC_WRITE_CSD              0x5b     //CMD27 дCSDĴ
#define MMC_SET_WRITE_PROT         0x5c     //CMD28
#define MMC_CLR_WRITE_PROT         0x5d     //CMD29
#define MMC_SEND_WRITE_PROT        0x5e     //CMD30
#define MMC_TAG_SECTOR_START       0x60     //CMD32 ʼַ
#define MMC_TAG_SECTOR_END         0x61     //CMD33 ַ
#define MMC_UNTAG_SECTOR           0x62     //CMD34
#define MMC_TAG_EREASE_GROUP_START 0x63     //CMD35
#define MMC_TAG_EREASE_GROUP_END   0x64     //CMD36
#define MMC_UNTAG_EREASE_GROUP     0x65     //CMD37
#define MMC_EREASE                 0x66     //CMD38 
#define MMC_READ_OCR               0x67     //CMD39 OCRĴ
#define MMC_CRC_ON_OFF             0x68     //CMD40 رCRCУ

#define SD_APP_COND                0x77     //CMD55  SDʼдCMD55дAMD41
#define SD_APP_OP_COND             0x69     //ACMD41 ʼSDMMCCMD1

/********************************************************************************
                    
********************************************************************************/
void initSPI (void);
uchar spiSendByte(const unsigned char data);
char mmc_GoIdle();
uchar mmcGetResponse(void);
uchar mmcGetXXResponse(const char resp);
uchar mmcCheckBusy(void);
void spiInit(void);
uchar spiSendByte(uchar data);
uchar mmcGoIdle();
uchar initMMC (void);
uchar mmcEreaseBlock(ulong Sector);
void mmcSendCmd (uchar cmd, ulong data, uchar crc);
uchar mmcSetBlockLength (uint blocklength);
uchar mmcReadBlock(ulong address, uint count, uchar *pBuffer);
#define mmcReadSector(sector, pBuffer) mmcReadBlock(sector*512ul, 512, pBuffer)  //Ϊݵַ
uchar mmcWriteBlock(ulong address, uint count, uchar *pBuffer);
#define mmcWriteSector(sector, pBuffer) mmcWriteBlock(sector*512ul, 512, pBuffer) //дΪдݵַ
uchar mmcReadRegister(uchar cmd_register, uchar length, uchar *pBuffer);
ulong MMC_ReadCardSize(void);
