//******************************************************************************
//DM430-AMMC/SDݶдʵ飬ļϵͳֱӶԴ洢в
//ͨTFTɫҺʾ״̬ʼ״̬ԼǷɹϢ
//MMC/SDMMC/SDΪSPI
//MSP430洢ݽṹΪСˣֽڵλַֽڸλַ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
//******************************************************************************

#include <msp430x14x.h>
#include "Config.h"
#include "SPI.c"
#include "MMC.c"
#include "TFT.c"
#include <stdio.h>
#include <string.h>

//***********************************************************************
//               ȫֱ
//***********************************************************************
ulong cardSize = 0;
uchar status = 1;
uint timeout = 0;
int i = 0;
uint BlockLength=512;                    //MMC/SDСCSDĴ¼˿ĴСһΪ512
ulong numSector=200;	                 //SDдݵĵַΪһΪ512ֽڵSDʵʵַΪnumSector*512ֽ
unsigned char buffer1[512];              //ݻ
unsigned char buffer2[512];              //ݻ

//***********************************************************************
//               MSP430IOڳʼ
//***********************************************************************
void Port_Init()
{
  LED8SEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  LED8DIR  = 0xFF;                      //IOڷΪ
  LED8PORT = 0xFF;                      //P2ڳʼΪFF
  
  DATASEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  DATADIR  = 0xFF;                      //IOڷΪ
  DATAPORT = 0xFF;                      //P4ڳʼΪFF
  
  CTRSEL  =  0x00;                      //IOΪͨI/Oģʽ˾ʡ
  CTRDIR |=  BIT3 + BIT4;               //IOڷΪ,ƿP63,P64
  CTRPORT =  0xFF;                      //P6ڳʼΪFF  
 
  P6SEL = 0x00;                         //IOΪͨI/Oģʽ˾ʡ
  P6DIR |= BIT2;                        //P62Ϊ
  P6OUT = 0xFF;                         //P6ڳʼΪFF
  
  P4SEL = 0x00;
  P4DIR = 0xFF;                         //ݿģʽ
  P5SEL = 0x00;
  P5DIR|= BIT0 + BIT1+ BIT2 + BIT5 + BIT6 + BIT7;   //TFTƿΪģʽ
  
  LCD_BL0;                              //Һ⣬͵ƽ
}

//***********************************************************************
//            SDʾ
//***********************************************************************
void SDsizeDisplay(ulong Capacity)
{
  static uint SizeQ,SizeB,SizeS,SizeG;
  ulong Size;
  DisplayString("SD Size:",0,8,0xeee);          //ʾSD
  Size=Capacity/1024/1024;
  SizeQ=Size/1000;
  SizeB=(Size%1000)/100;
  SizeS=(Size%1000)%100/10;
  SizeG=(Size%1000)%100%10;
  DisplayChar(SizeQ+'0',8,8,0xffff);
  DisplayChar(SizeB+'0',9,8,0xffff);
  DisplayChar(SizeS+'0',10,8,0xffff);
  DisplayChar(SizeG+'0',11,8,0xffff);
  DisplayString("MB",13,8,0xf800);  		  //ʾSDλ
}

//***********************************************************************
//              ʾ
//***********************************************************************
void NoCardRing(void)
{
  SOUNDON;                                        //P62õͣ
  delay_ms(200);                                  //ʱ200ms
  SOUNDOFF;                                       //P62øߣر
  delay_ms(200);                                  //ʱ200ms
  SOUNDON;                                        //P62õͣ
  delay_ms(200);                                  //ʱ200ms
  SOUNDOFF;                                       //P62øߣر
  delay_ms(200);                                  //ʱ200ms
  SOUNDON;                                        //P62õͣ
  delay_ms(200);                                  //ʱ200ms
  SOUNDOFF;                                       //P62øߣر
  delay_ms(200);                                  //ʱ200ms
}

//***********************************************************************
//              ʾʼ
//***********************************************************************
void DeskInit(void)
{
  DisplayString("DM430-A Board ",0,0,0xf800);     //ַʾ
  DisplayString("SD Read & Write ",0,2,0xeee);    //ַʾ
  DisplayString("Start Testing...",0,3,0xeee);	  //ַʾ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ  
  //delay_ms(1000);				  //ʱ
  //DisplayData();			          //ֵַ
  DisplayString("Starting Init SD",0,4,0xeee);    //ַʾ
  DisplayString("Waiting...",0,5,0xeee);          //ַʾ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
}

//***********************************************************************
//              
//***********************************************************************
int main( void )
{
  uchar success=0;
  
  WDT_Init();                                     //Ź
  Clock_Init();                                   //ϵͳʱ
  Port_Init();                                    //˿ڳʼ
  Close_LED();                                    //رʾ
  LCD_RD1; 
  LCD_Init();                                     //TFTʼ
  LCD_clear(0);                                   //
  
  DeskInit();                                     //ʾʼ
                
  while (status != 0)                             //طֵʾSD³ʼ                                           
  {
    status = initMMC();
    timeout++;
    if (timeout == 50)                            //ʼ50MMC/SDȻش룬ʼʧܣûSD
    {
      DisplayString("Init Failure",0,7,0xf800);   //ַʾ
      DisplayString("Please Check SD",0,8,0xf800);//ַʾ
      NoCardRing();                               //ʾMMC/SDʼʧܣǷװã߸ʽÿ
      while(1);                                   //˳Ǹλϵ
    }
  }   
  DisplayString("Init SD Success!",0,6,0xeee);    //ַʾ
  cardSize =  MMC_ReadCardSize();                 //CSDĴȡMMC/SDСس
  SDsizeDisplay(cardSize);
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  LCD_clear(0);				          //
  DisplayString("DM430-A Board ",0,0,0xf800);     //ַʾ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  DisplayString("Start Write... ",0,2,0xeee);     //ַʾ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  buffer1[0]='A';
  for(i=1;i<512;i++)
  {
    buffer1[i]=buffer1[0];   	                  //ݻbuffer1
  }
  
  mmcWriteSector(numSector, buffer1);             //ַָ(numSector*512)д
  DisplayString("Write Finished!",0,3,0xeee);     //ַʾ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  
  DisplayString("Start Read... ",0,4,0xeee);      //ַʾ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  mmcReadSector(numSector, buffer2);	          //ȡղдռݣжǷдɹ
  DisplayString("Read Finished!",0,5,0xeee);      //ַʾ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  delay_ms(1000);				  //ʱΪ˸Ŀ̣ʵӦвҪ
  
  DisplayString("Start verify...",0,6,0xeee);     //ʼУ飬֤дǷһ

  for(i=0;i<BlockLength;i++)                       //ж϶дǷɹдǷһ
  {
    if(buffer1[i]!=buffer2[i])                     //ݶдʧ
    {
      DisplayString("Verify Failure!",0,7,0xeee);  //Уʧ
      DisplayString("Test Failure!",0,8,0x8232);   //Գɹ
      success=0;
      break;
    }
    else success=1;
  }
  if(success==1)  DisplayString("Verify Success!",0,7,0xeee);      //Уɹ
  DisplayString("Test Success!",0,8,0x8232);                       //Գɹ
  while(1);
}